import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.util.Enumeration;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
//import javax.swing.filechooser.FileNameExtensionFilter;


public class FDBAppletDialog extends JDialog implements ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	//Ăяo
	FDBFrame frame;
	FDBFileIO fileIO;
	//
	File pathHTML=null;
	//---------------------------------------------
	JTextField fieldPath=new JTextField("",20);
	JButton buttonPath=new JButton("w");
	JTextField fieldTitle=new JTextField("FullDirectionBlock",15);
	//
	JTextField fieldOmake=new JTextField("",20);
	//
	DefaultComboBoxModel comboModelStart=new DefaultComboBoxModel();
	//
	JRadioButton radioContOn=new JRadioButton("On",true);
	JRadioButton radioContOff=new JRadioButton("Off");
	//
	JCheckBox checkSaveLoad=new JCheckBox("Z[u[h");
	JCheckBox checkSelectAll=new JCheckBox("Xe[WIiBj");
	JCheckBox checkSelectPart=new JCheckBox("Xe[WIiSj");
	//
	JTextField fieldSet=new JTextField("",3);
	JTextField fieldBlock=new JTextField("",3);
	JTextField fieldSE=new JTextField(FDBFileIO.SE_FOLDER,3);
	//
	JButton buttonOk=new JButton("o");
	JButton buttonCancel=new JButton("");
	//
	//*************************************************************
	//
	//-------------------------------------------------------------
	public FDBAppletDialog(FDBFrame frm,FDBFileIO fIO){
		super(frm,"Weby[Wo",true);
		//
		frame=frm;
		fileIO=fIO;
		//
		fieldPath.setEditable(false);	//ڂ͕ҏWłȂ
		ButtonGroup radioGroup=new ButtonGroup();
		radioGroup.add(radioContOn);
		radioGroup.add(radioContOff);
		//
		JPanel htmlOutPanel=new JPanel();	//1-1
		htmlOutPanel.setLayout(new BorderLayout());
		htmlOutPanel.add(new JLabel("o͐F"),BorderLayout.CENTER);
		htmlOutPanel.add(buttonPath,BorderLayout.EAST);
		htmlOutPanel.add(fieldPath,BorderLayout.SOUTH);
		//
		JPanel htmlTitlePanel=new JPanel();	//1-2
		htmlTitlePanel.add(new JLabel("^CgF"));
		htmlTitlePanel.add(fieldTitle);
		//
		JPanel htmlPanel=new JPanel();		//1
		htmlPanel.setLayout(new BorderLayout());
		htmlPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"Weby[W"));	//g
		htmlPanel.add(htmlOutPanel,BorderLayout.CENTER);	//1-1
		htmlPanel.add(htmlTitlePanel,BorderLayout.SOUTH);	//1-2
		//
		JPanel omakePanel=new JPanel();		//2-1
		omakePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"܂y[W"));	//g
		omakePanel.add(fieldOmake);
		//
		JPanel startPanel=new JPanel();		//2-2
		startPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"JnXe[W"));	//g
		startPanel.add(new JComboBox(comboModelStart));
		//
		JPanel contPanel=new JPanel();		//2-3
		contPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"ReBj["));	//g
		contPanel.add(radioContOn);
		contPanel.add(radioContOff);
		//
		JPanel optionPanel=new JPanel();	//2-4
		optionPanel.setLayout(new GridLayout(3,1));
		optionPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"IvV"));	//g
		optionPanel.add(checkSaveLoad);
		optionPanel.add(checkSelectAll);
		optionPanel.add(checkSelectPart);
		//
		JPanel folderSetPanel=new JPanel();	//2-5-1
		folderSetPanel.add(new JLabel("Xe[WݒF"));
		folderSetPanel.add(fieldSet);
		folderSetPanel.add(new JLabel("/ s000.txt"));
		//
		JPanel folderBlockPanel=new JPanel();	//2-5-1
		folderBlockPanel.add(new JLabel("ubNzuF"));
		folderBlockPanel.add(fieldBlock);
		folderBlockPanel.add(new JLabel("/ b000.csv"));
		//
		JPanel folderSEPanel=new JPanel();	//2-5-1
		folderSEPanel.add(new JLabel("ʉF"));
		folderSEPanel.add(fieldSE);
		folderSEPanel.add(new JLabel("/ *.au(wav)"));
		//
		JPanel folderPanel=new JPanel();	//2-5
		folderPanel.setLayout(new GridLayout(3,1));
		folderPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"o̓tH_"));	//g
		folderPanel.add(folderSetPanel);
		folderPanel.add(folderBlockPanel);
		folderPanel.add(folderSEPanel);
		//
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.fill=GridBagConstraints.BOTH;
		GridBagLayout gbl=new GridBagLayout();
		JPanel centerPanel=new JPanel();	//2
		centerPanel.setLayout(gbl);
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=1;
		gbl.setConstraints(omakePanel,gbc);
		centerPanel.add(omakePanel);		//2-1
		gbc.gridwidth=1;
		gbc.gridheight=1;
		gbl.setConstraints(startPanel,gbc);
		centerPanel.add(startPanel);		//2-2
		gbc.gridwidth=GridBagConstraints.REMAINDER;;
		gbc.gridheight=1;
		gbl.setConstraints(contPanel,gbc);
		centerPanel.add(contPanel);		//2-3
		gbc.gridwidth=1;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbl.setConstraints(optionPanel,gbc);
		centerPanel.add(optionPanel);		//2-4
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbl.setConstraints(folderPanel,gbc);
		centerPanel.add(folderPanel);		//2-5
		//
		JPanel panelBtn=new JPanel();		//3
		panelBtn.add(buttonOk);
		panelBtn.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(htmlPanel,BorderLayout.NORTH);
		cp.add(centerPanel,BorderLayout.CENTER);
		cp.add(panelBtn,BorderLayout.SOUTH);
		//ẽCxg
		buttonPath.addActionListener(this);
		checkSelectAll.addActionListener(this);
		checkSelectPart.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//*************************************************************
	//_CAO\Ȍ
	//-------------------------------------------------------------
	public void setLatestData(int stg){
		//쐬
		comboModelStart.removeAllElements();
		for(int s=1;s<=stg;s++){
			comboModelStart.addElement(String.valueOf(s));
		}
	}
	//*************************************************************
	//Cxg
	//-------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonPath){
			File file=fileIO.chooseFileOnSave("o͐Weby[W(*.htm,*.html)w","w",pathHTML,/*new FileNameExtensionFilter("Weby[W(*.htm,*.html)","htm","html")*/"htm","html");
			if(file!=null){
				pathHTML=file;
				fieldPath.setText(pathHTML.getPath());
			}
		}else if(object==checkSelectAll){
			if(checkSelectAll.isSelected()){
				checkSelectPart.setSelected(false);
			}
		}else if(object==checkSelectPart){
			if(checkSelectPart.isSelected()){
				checkSelectAll.setSelected(false);
			}
		}else if(object==buttonOk){
			if(pathHTML==null){
				frame.showErrorDialog("o͐Weby[Ww肵Ă");
				return;
			}
			//o
			if(outputWebFiles()){
				//G[IȂ
				frame.showFinishDialog("o͂܂");
				setVisible(false);
			}
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//*************************************************************
	//ftHg̃Xe[WݒɁAo͗pɍڂ
	//-------------------------------------------------------------
	private String getDefaultSetString(){
		//ftHg̃Xe[Wݒ𓾂
		FDBSetFile s0=new FDBSetFile(frame);
		s0.setDefaultData(fileIO.getFileString(FDBFileIO.getTargetStageFileName(0)));
		//JnXe[Wǉ
		int start=Integer.parseInt((String)(comboModelStart.getSelectedItem()));
		if(start!=1){
			s0.gStageStart=start;
		}
		//ReBj[ǉ
		if(radioContOff.isSelected()){
			s0.gStageContinue=false;
		}
		//܂y[Wǉ
		String omake=fieldOmake.getText();
		if(!omake.equals("")){
			s0.gPremiumPage=omake;
		}
		//
		return s0.getDefaultDataString();
	}
	//*************************************************************
	//Appletgpt@Co
	//-------------------------------------------------------------
	private boolean outputWebFiles(){
		//
		JarFile selfJarFile=fileIO.getSelfJarFile();
		int[] setInfo=fileIO.getSetInfo(true);
		int stageMax=comboModelStart.getSize();
		//
		try{
			//HTML
			FDBFileIO.makeTextFile(pathHTML, getHTMLString(setInfo,stageMax));
			//AppletNJar
			FDBFileIO.outFromJarToFolder(selfJarFile, "takanablock.jar", pathHTML.getParentFile());
			//VXe摜
			Enumeration<JarEntry> entries=selfJarFile.entries();
			while(entries.hasMoreElements()){
				JarEntry entry=(JarEntry)entries.nextElement();
				if(FDBFileIO.checkEntryExtention(entry, ".gif")){	//GIF摜iVXegp摜jȂSĉ
					FDBFileIO.outFromJarToFolder(selfJarFile, entry.getName(), pathHTML.getParentFile());
				}
			}
			//Xe[WݒAubNzu
			String sFolderPlusSep=getFolderPlusSep(fieldSet.getText());
			String bFolderPlusSep=getFolderPlusSep(fieldBlock.getText());
			//	iXe[Wݒ̓ftHgɂ͒ǉvfAʈj
			File sBeforeFile=null;
			File sAfterFile=new File(pathHTML.getParent()+FDBFileIO.SEP+sFolderPlusSep+FDBFileIO.getTargetStageFileName(0));	//tH_w
			FDBFileIO.makeTextFile(sAfterFile,getDefaultSetString());	//t@C̃Rs[łȂAeLXgt@Cɏ
			//	iubNzu̓ftHgłj
			File bBeforeFile=fileIO.getWorkFile(FDBFileIO.getTargetBlockFileName(0));
			File bAfterFile=new File(pathHTML.getParent()+FDBFileIO.SEP+bFolderPlusSep+FDBFileIO.getTargetBlockFileName(0));	//tH_w
			FDBFileIO.copyFile(bBeforeFile, bAfterFile);
			//	iftHgȊO͂܂Ƃ߂ă[vj
			for(int s=1;s<=stageMax;s++){
				//
				sBeforeFile=fileIO.getWorkFile(FDBFileIO.getTargetStageFileName(s));
				sAfterFile=new File(pathHTML.getParent()+FDBFileIO.SEP+sFolderPlusSep+FDBFileIO.getTargetStageFileName(s));	//tH_w
				FDBFileIO.copyFile(sBeforeFile, sAfterFile);
				//
				bBeforeFile=fileIO.getWorkFile(FDBFileIO.getTargetBlockFileName(s));
				bAfterFile=new File(pathHTML.getParent()+FDBFileIO.SEP+bFolderPlusSep+FDBFileIO.getTargetBlockFileName(s));	//tH_w
				FDBFileIO.copyFile(bBeforeFile, bAfterFile);
			}
			//ʉ
			switch(setInfo[FDBFileIO.SET_DATA_SOUND]){
			case FDBFrame.SND_IN:
				//t@CXɎw
				for(int s=0;s<FDBSound.SE_ALL;s++){
					FDBFileIO.outFromJarToFolder(selfJarFile,FDBFileIO.SE_FOLDER+'/'+FDBSound.SOUND_NAME[s]+".au",		//JARseparator'/'
							pathHTML.getParentFile(),getFolderPlusSep(fieldSE.getText())+FDBSound.SOUND_NAME[s]+".au");	//ʉ̓tH_ς邩
				}
				break;
			case FDBFrame.SND_OFF:
				break;
			case FDBFrame.SND_OUT_WAV:
			case FDBFrame.SND_OUT_AU:
				copyWorkFiles(FDBFileIO.SE_FOLDER,getFolderPlusSep(fieldSE.getText()));		//tH_St@C
			}
			//wi摜
			copyWorkFiles(FDBFileIO.BACK_FOLDER,FDBFileIO.BACK_FOLDER+FDBFileIO.SEP);		//tH_St@C
			//FormŎgJavaScript
			if(checkSaveLoad.isSelected() || checkSelectAll.isSelected() || checkSelectPart.isSelected()){
				FDBFileIO.outFromJarToFolder(selfJarFile, "block.js", pathHTML.getParentFile());
			}
			//
			return true;
		}catch(IOException e){
			frame.showErrorDialog("o͂Ɏs܂"+FDBFileIO.BR+e.toString());
			return false;
		}catch(NullPointerException npe){	//selfJarɖړĨt@CȂ
			frame.showErrorDialog("o͂Ɏs܂"+FDBFileIO.BR+npe.toString());
			return false;
		}
	}
	//ƃtH_̎wtH_St@CRs[
	private void copyWorkFiles(String folderInWork,String afterFolderPlusSep) throws IOException{
		File beforeFolder=fileIO.getWorkFile(folderInWork);
		if(beforeFolder.exists()){
			String[] targetNames=beforeFolder.list();
			for(int b=0;b<targetNames.length;b++){
				File before=new File(beforeFolder.getPath()+FDBFileIO.SEP+targetNames[b]);
				File after=new File(pathHTML.getParent()+FDBFileIO.SEP+afterFolderPlusSep+targetNames[b]);
				FDBFileIO.copyFile(before, after);	//Ńt@C`FbNĂ
			}
		}
	}
	//t@C܂Ƃ߂ătH_ɓ邩Ȃseparator
	private String getFolderPlusSep(String folder){
		if(folder.equals("")){
			return folder;
		}else{
			return folder+FDBFileIO.SEP;
		}
	}
	//*************************************************************
	//o͂HTML̓e
	//-------------------------------------------------------------
	private String getHTMLString(int[] setInfo,int stageMax){
		StringBuffer outString=new StringBuffer();
		//		HTML start
		outString.append("<html>").append(FDBFileIO.BR);
		outString.append("<head>").append(FDBFileIO.BR);
		outString.append("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;CHARSET=x-sjis\">").append(FDBFileIO.BR);
		if(checkSaveLoad.isSelected() || checkSelectAll.isSelected() || checkSelectPart.isSelected()){
			outString.append("<script src=\"block.js\" type=\"text/javascript\"></script>").append(FDBFileIO.BR);
		}
		outString.append("<title>"+fieldTitle.getText()+"</title>").append(FDBFileIO.BR);
		outString.append("</head>").append(FDBFileIO.BR);
		outString.append("<body>").append(FDBFileIO.BR);
		outString.append("<center>").append(FDBFileIO.BR);
		//		Applet start
		outString.append("<applet code=\"FDBlock.class\" archive=\"takanablock.jar\" ");
		outString.append("width=\""+setInfo[FDBFileIO.SET_DATA_WIDTH]+"\" height=\""+setInfo[FDBFileIO.SET_DATA_HEIGHT]+"\" name=\"applet\">").append(FDBFileIO.BR);
		//		set , block
		if(!fieldSet.getText().equals("")){
			outString.append("<param name=\"setupfilename\" value=\""+fieldSet.getText()+"/s\">").append(FDBFileIO.BR);
		}
		if(!fieldBlock.getText().equals("")){
			outString.append("<param name=\"blockfilename\" value=\""+fieldBlock.getText()+"/b\">").append(FDBFileIO.BR);
		}
		//		SE
		if(setInfo[FDBFileIO.SET_DATA_SOUND]==FDBFrame.SND_OFF){
			outString.append("<param name=\"sound\" value=\"off\">").append(FDBFileIO.BR);
		}else if(setInfo[FDBFileIO.SET_DATA_SOUND]==FDBFrame.SND_OUT_WAV){
			outString.append("<param name=\"soundextension\" value=\"wav\">").append(FDBFileIO.BR);
		}else{
			if(!fieldSE.getText().equals("se")){
				outString.append("<param name=\"sound\" value=\""+fieldSE.getText()+"\">").append(FDBFileIO.BR);
			}
		}
		//		debug
		if(frame.menuItemDebugOn.isSelected()){			//***
			outString.append("<param name=\"debug\" value=\"on\">").append(FDBFileIO.BR);
		}
		//		Applet end
		outString.append("</applet>").append(FDBFileIO.BR);
		outString.append("<br><br>").append(FDBFileIO.BR);
		outString.append("ɂ<a href=\"http://java.com/ja/\">Javas</a>Kvł").append(FDBFileIO.BR);
		//		Form
		if(checkSaveLoad.isSelected() || checkSelectAll.isSelected() || checkSelectPart.isSelected()){
			outString.append("<form>").append(FDBFileIO.BR);
		}
		if(checkSaveLoad.isSelected()){
			outString.append("<input type=\"button\" value=\"ۑ\" onClick=\"save(applet)\">").append(FDBFileIO.BR);
			outString.append("<input type=\"button\" value=\"Ăяo\" onClick=\"load(applet)\">").append(FDBFileIO.BR);
			outString.append("<input type=\"button\" value=\"폜\" onClick=\"remove()\"><br>").append(FDBFileIO.BR);
			outString.append("iXe[WJñf[^ۑj<br>").append(FDBFileIO.BR);
		}
		if(checkSelectAll.isSelected()){
			outString.append("<select name=\"select1\">").append(FDBFileIO.BR);
			outString.append("<option>Xe[WI</option>").append(FDBFileIO.BR);
			for(int s=0;s<stageMax;s++){
				outString.append("<option>"+(s+1)+"</option>").append(FDBFileIO.BR);
			}
			outString.append("</select>").append(FDBFileIO.BR);
			outString.append("<input type=\"button\" value=\"Xe[WI\" onClick=\"choice(applet,select1,false)\"><br>").append(FDBFileIO.BR);
			outString.append("iBXe[W܂őI\j<br>").append(FDBFileIO.BR);
		}else if(checkSelectPart.isSelected()){
			outString.append("<select name=\"select2\">").append(FDBFileIO.BR);
			outString.append("<option>Xe[WI</option>").append(FDBFileIO.BR);
			for(int s=0;s<stageMax;s++){
				outString.append("<option>"+(s+1)+"</option>").append(FDBFileIO.BR);
			}
			outString.append("</select>").append(FDBFileIO.BR);
			outString.append("<input type=\"button\" value=\"Xe[WI\" onClick=\"choice(applet,select2,true)\"><br>").append(FDBFileIO.BR);
			outString.append("iSXe[WI\j<br>").append(FDBFileIO.BR);
		}
		if(checkSaveLoad.isSelected() || checkSelectAll.isSelected() || checkSelectPart.isSelected()){
			outString.append("<br>").append(FDBFileIO.BR);
			outString.append("uEUJavaScriptCookie͗LɂĂ").append(FDBFileIO.BR);
			outString.append("</form>").append(FDBFileIO.BR);
		}
		//		HTML end
		outString.append("</center>").append(FDBFileIO.BR);
		outString.append("</body>").append(FDBFileIO.BR);
		outString.append("</html>").append(FDBFileIO.BR);
		//
		return outString.toString();
	}
}
