import java.awt.*;

public class FDBBall
{
	//-------------------------------------
	//move̖߂l
	static final int R_CONTINUE=0;
	static final int R_BALL_OUT=1;
	static final int R_GAME_OVER=2;
	static final int R_STAGE_CLEAR=3;
	//-------------------------------------
	int count;	//tB[h̃{[܂߂
	//
	int speedNormal;
	int speedFast;
	int speedSlow;
	int speedNow;
	//
	int radiusNormal;
	int radiusBig;
	int radiusSmall;
	int radiusNow;
	//
	Color color;
	//͂̌ʌW
	int effectRate;
	//
	int combo;
	//
	int posX;
	int posY;
	double angle;
	//͂܂΍Ŏg
	int oldPosX;
	int oldPosY;
	double oldAngle;	//Itemłg
	//
	int addX;
	int addY;
	//JavaScriptgp@\̃f[^
	int stageStartCount;
	//------------------------------
	//
	//------------------------------
	//Rs[p̃RXgN^i{[ACeŊpxςĕj
	public FDBBall(FDBBall ball,int all,int num){
		//
		count=ball.count;
		//
		speedNormal=ball.speedNormal;
		speedFast=ball.speedFast;
		speedSlow=ball.speedSlow;
		speedNow=ball.speedNow;
		//
		radiusNormal=ball.radiusNormal;
		radiusBig=ball.radiusBig;
		radiusSmall=ball.radiusSmall;
		radiusNow=ball.radiusNow;
		//
		color=ball.color;
		//
		effectRate=ball.effectRate;
		//
		combo=0;
		//
		posX=ball.posX;
		posY=ball.posY;
		angle=controlAngle( ball.angle + 2*Math.PI*(num+1)/(all+1) );
		//
		oldPosX=posX;
		oldPosY=posY;
		oldAngle=angle;
		//
		stageStartCount=ball.stageStartCount;
	}
	//ʏ̃RXgN^
	public FDBBall(FDBStageLoader stage){
		//
		formatBall(stage);
	}
	//RXgN^łȂXe[WłĂ΂
	public void formatBall(FDBStageLoader stage){
		//F_CONTINUEȂcountz
		if(stage.s1.ballCount!=FDBSetFile.BALL_CONTINUE_IN){
			count=stage.s1.ballCount;
		}
		//
		speedNormal=stage.s1.ballSpeed;
		speedFast=(int)(speedNormal*3/2);
		speedSlow=(int)(speedNormal*2/3);
		speedNow=speedNormal;
		//
		radiusNormal=stage.s1.ballRadius;
		radiusBig=(int)(radiusNormal*3/2);
		radiusSmall=(int)(radiusNormal*2/3);
		radiusNow=radiusNormal;
		//
		color=stage.s1.ballColor;
		//
		effectRate=stage.s1.powerEffect;
		//
		combo=0;
		//JavaScriptgp@\̃f[^
		stageStartCount=count;
	}
	//Xe[W̎ƔˑOo[ړ̎ɌĂ΂
	public void setBallPosition(int fieldWidth,int fieldHeight,FDBBars bars){
		double fazzy=Math.PI/12;	//px
		if(!bars.directionFlag[FDBBars.D_DOWN]){
			posX=bars.barPosX;
			posY=fieldHeight-bars.barOverhang-radiusNow;
			angle=Math.PI*3/2+fazzy;
		}else if(!bars.directionFlag[FDBBars.D_RIGHT]){
			posX=fieldWidth-bars.barOverhang-radiusNow;
			posY=bars.barPosY;
			angle=Math.PI+fazzy;
		}else if(!bars.directionFlag[FDBBars.D_UP]){
			posX=bars.barPosX;
			posY=bars.barOverhang+radiusNow;
			angle=Math.PI/2+fazzy;
		}else if(!bars.directionFlag[FDBBars.D_LEFT]){
			posX=bars.barOverhang+radiusNow;
			posY=bars.barPosY;
			angle=0+fazzy;
		}else{
			posX=(int)(fieldWidth/2);
			posY=fieldHeight-radiusNow;
			angle=Math.PI*3/2+fazzy;
		}
		//```͂܂΍```
		oldPosX=posX;
		oldPosY=posY;
		oldAngle=angle;
		//```````````
	}
	//---------------------------------------
	//c胉Ct\peLXgiFDBlock΂j
	//---------------------------------------
	public String getCountString(){
		if(count>0){
			return String.valueOf(count-1);	//tB[h̃{[͊܂߂Ȃ
		}else if(count==0){
			return "-";	//Q[I[o[
		}else{
			return "";
		}
	}
	//----------------------------------------------------------
	//{[ACe̔
	//----------------------------------------------------------
	public void operateLifeFromItem(int typePair){
		if(count<0){ return; }
		if(typePair==FDBItem.I_PAIR_UP){
			count++;
		}else/* if(typePair==Item.I_PAIR_DOWN)*/{
			if(count>1){	count--;	}
		}
	}
	//----------------------------------------------------------
	//͂󂯂ĕςirunł΂j
	//----------------------------------------------------------
	public void receiveRepelPower(Point repelPoint){
		if(repelPoint==null){	return;	}
		//
		double relativeAngle;
		if(effectRate>=0){
			relativeAngle=controlRelativeAngle(Math.atan2(posY-repelPoint.y,posX-repelPoint.x)-angle);	//͂ւ̑Ίpx
			angle+=relativeAngle*effectRate/1000;	//͂̑傫𒲐ĉ
		}else{
			relativeAngle=controlRelativeAngle(Math.atan2(repelPoint.y-posY,repelPoint.x-posX)-angle);	//z͂ւ̑Ίpx
			angle-=relativeAngle*effectRate/1000;	//͂̑傫𒲐ĉ
		}
	}
	//----------------------------------------------------------
	//Ԍo߂ɔړirunł΂j
	//----------------------------------------------------------
	public int move(int fieldWidth,int fieldHeight,FDBBlocks blocks,FDBBars bars,FDBGeneral general,FDBItemManager items,FDBSound sounds){
		//
		addX=(int)(speedNow*Math.cos(angle));
		addY=(int)(speedNow*Math.sin(angle));
		//+++++++++++++++++++++++++++++++++
		//BarsƂ̓蔻
		if(posX+addX<bars.barOverhang+radiusNow){	//LEFT
			if(bars.directionFlag[FDBBars.D_LEFT]){	//WALL
				if(posX+addX<radiusNow){	//
					wallReflexLeft(sounds);
				}
			}else{	//BAR
				if(posX+addX<-radiusNow){	//out of field
					if(Math.abs(posY+addY-bars.barPosY)>bars.barLength/2){	//out of bar length
						if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]==null){
							return ballOut();
						}else{	//Item(keep in)
							wallReflexLeft(sounds);
						}
					}else{
						if( !checkBarTouch(posX+addX,posY+addY,bars.barOverhang-bars.barRadius,bars.barPosY,radiusNow+bars.barRadius,sounds) ){
							//out of bar
							if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]==null){
								return ballOut();
							}else{	//Item(keep in)
								wallReflexLeft(sounds);
							}
						}
					}
				}else{	//in field
					if( !checkBarTouch(posX+addX,posY+addY,bars.barOverhang-bars.barRadius,bars.barPosY,radiusNow+bars.barRadius,sounds) ){
						//out of bar
						//Item(keep in)
						if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]!=null){
							if(posX+addX<radiusNow){
								wallReflexLeft(sounds);
							}
						}
					}
				}
			}
		}else if(posX+addX>fieldWidth-bars.barOverhang-radiusNow){	//RIGHT
			if(bars.directionFlag[FDBBars.D_RIGHT]){	//WALL
				if(posX+addX>fieldWidth-radiusNow){
					wallReflexRight(fieldWidth,sounds);
				}
			}else{	//BAR
				if(posX+addX>fieldWidth+radiusNow){	//out of field
					if(Math.abs(posY+addY-bars.barPosY)>bars.barLength/2){	//out of bar length
						if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]==null){
							return ballOut();
						}else{	//Item(keep in)
							wallReflexRight(fieldWidth,sounds);
						}
					}else{
						if( !checkBarTouch(posX+addX,posY+addY,fieldWidth-bars.barOverhang+bars.barRadius,bars.barPosY,radiusNow+bars.barRadius,sounds) ){
							//out of bar
							if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]==null){
								return ballOut();
							}else{	//Item(keep in)
								wallReflexRight(fieldWidth,sounds);
							}
						}
					}
				}else{	//in field
					if( !checkBarTouch(posX+addX,posY+addY,fieldWidth-bars.barOverhang+bars.barRadius,bars.barPosY,radiusNow+bars.barRadius,sounds) ){
						//out of bar
						//Item(keep in)
						if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]!=null){
							if(posX+addX>fieldWidth-radiusNow){
								wallReflexRight(fieldWidth,sounds);
							}
						}
					}
				}
			}
		}
		//
		if(posY+addY<bars.barOverhang+radiusNow){	//UP
			if(bars.directionFlag[FDBBars.D_UP]){	//WALL
				if(posY+addY<radiusNow){
					wallReflexUp(sounds);
				}
			}else{	//BAR
				if(posY+addY<-radiusNow){	//out of field
					if(Math.abs(posX+addX-bars.barPosX)>bars.barLength/2){	//out of bar length
						if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]==null){
							return ballOut();
						}else{	//Item(keep in)
							wallReflexUp(sounds);
						}
					}else{
						if( !checkBarTouch(posX+addX,posY+addY,bars.barPosX,bars.barOverhang-bars.barRadius,radiusNow+bars.barRadius,sounds) ){
							//out of bar
							if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]==null){
								return ballOut();
							}else{	//Item(keep in)
								wallReflexUp(sounds);
							}
						}
					}
				}else{	//in field
					if( !checkBarTouch(posX+addX,posY+addY,bars.barPosX,bars.barOverhang-bars.barRadius,radiusNow+bars.barRadius,sounds) ){
						//out of bar
						//Item(keep in)
						if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]!=null){
							if(posY+addY<radiusNow){
								wallReflexUp(sounds);
							}
						}
					}
				}
			}
		}else if(posY+addY>fieldHeight-bars.barOverhang-radiusNow){	//DOWN
			if(bars.directionFlag[FDBBars.D_DOWN]){	//WALL
				if(posY+addY>fieldHeight-radiusNow){
					wallReflexDown(fieldHeight,sounds);
				}
			}else{	//BAR
				if(posY+addY>fieldHeight+radiusNow){	//out of field
					if(Math.abs(posX+addX-bars.barPosX)>bars.barLength/2){	//out of bar length
						if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]==null){
							return ballOut();
						}else{	//Item(keep in)
							wallReflexDown(fieldHeight,sounds);
						}
					}else{
						if( !checkBarTouch(posX+addX,posY+addY,bars.barPosX,fieldHeight-bars.barOverhang+bars.barRadius,radiusNow+bars.barRadius,sounds) ){
							//out of bar
							if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]==null){
								return ballOut();
							}else{	//Item(keep in)
								wallReflexDown(fieldHeight,sounds);
							}
						}
					}
				}else{	//in field
					if( !checkBarTouch(posX+addX,posY+addY,bars.barPosX,fieldHeight-bars.barOverhang+bars.barRadius,radiusNow+bars.barRadius,sounds) ){
						//out of bar
						//Item(keep in)
						if(items.effectiveItemArr[FDBItem.I_TIME_MONO_REFLEX]!=null){
							if(posY+addY>fieldHeight-radiusNow){
								wallReflexDown(fieldHeight,sounds);
							}
						}
					}
				}
			}
		}
		//++++++++++++++++++++++++++++++++++++
		//BlocksƂ̓蔻
		int blockTouchResult=blocks.checkTouchBlock(posX,posY,addX,addY,radiusNow,items);
		//ubNɓ΁iȂ牽Ȃj
		if(blockTouchResult!=FDBBlocks.T_NO_TOUCH){
			//ړʂ𓖂Ă͂߁||Blocks̈ꎞϐgp
			addX=blocks.tmpAddX;
			addY=blocks.tmpAddY;
			//```js\Block̊pł͂܂ꍇ̑Ή```
			if(oldPosX==posX && oldPosY==posY){
				//܂EoĂȂ
				if(addX==0 && addY==0){
					//˕Ԃ点ApxEo₷ɂ炵Ă
					if(controlRelativeAngle(oldAngle-blocks.tmpReflectBaseAngle)>=0){	//||Blocks̈ꎞϐgp
						angle-=Math.PI/6;
					}else{
						angle+=Math.PI/6;
					}
				}	//Eo͊pxȂA˂Ȃ
			}else{
				//͂܂ĂȂΒ˕Ԃ点i{[ђʃACeĂȂ΁j
				if(items.effectiveItemArr[FDBItem.I_TIME_MONO_THROUGH]==null){
					angle=calculateReflectAngle(angle,blocks.tmpReflectBaseAngle);	//||Blocks̈ꎞϐgp
				}
			}
			//```````````````````````
			//j\ubNɓȂ
			if(blockTouchResult!=FDBBlocks.T_TOUCH_UNBREAKABLE){
				if( countBonus( general.addScore(combo) ) ){	//_Z
					sounds.playSE(FDBSound.SE_CATCH);
				}
				//
				if(blockTouchResult==FDBBlocks.T_TOUCH_BREAK_NOT_CLEAR){
					items.addItem(this);	//ubNj󂵂ACesiw肵mŔj
					combo++;
					//
					sounds.playSE(FDBSound.SE_BREAK);
				}else if(blockTouchResult==FDBBlocks.T_TOUCH_DECREASE){
					combo++;
					//
					sounds.playSE(FDBSound.SE_BREAK);
				}else if(blockTouchResult==FDBBlocks.T_TOUCH_BREAK_CLEAR){	//NA猋ʂԂďI
					posX+=addX;
					posY+=addY;
					//
					return R_STAGE_CLEAR;
				}
			}else{
				//jubNɓȂ璵˕Ԃ邾
				sounds.playSE(FDBSound.SE_REFLEX);
			}
		}
		//+++++++++++++++++++++++++++++++++
		//
		//````͂܂΍````
		//͂܂ĂԂ͌Âlۂ
		if(addX!=0 || addY!=0){	oldAngle=angle;	}
		//ɍXViړʃ[ȂsvHj
		oldPosX=posX;
		oldPosY=posY;
		//`````````````
		//ωʂʒuWɉi{[͊OɏoȂAǁEo[EubNɂ͓Ȃj
		posX+=addX;
		posY+=addY;
		//
		return R_CONTINUE;
	}
	//_ɔc胉Ct̏
	//iGeneralState̓_ACełgÂ߂Ƀ\bhj
	public boolean countBonus(boolean f){
		if( f && count>0 ){
			count++;
			return true;
		}else{
			return false;
		}
	}
	//{[tB[hOɏȍiʂԂmove͏Ij
	private int ballOut(){
		//ωʂʒuWɉiQ[I[o[̎ɕKvHj
		posX+=addX;
		posY+=addY;
		//
		if(count>0){
			count--;
			if(count==0){
				return R_GAME_OVER;
			}else{
				return R_BALL_OUT;
			}
		}else if(count<0){	//c胉Ct
			return R_BALL_OUT;
		}else{
			return R_GAME_OVER;	//damyiN肦Ȃj
		}
		//
	}
	//ǔ˂̕ʏi܂move͏IȂj
	private void wallReflexLeft(FDBSound sounds){
		if(addX!=0){
			addY=(int)(addY*(radiusNow-posX)/addX);
			addX=radiusNow-posX;
		}else{	//[Z΍iʏ͋NȂ͂j
			addY=addX;
		}
		angle=calculateReflectAngle(angle,0);
		//
		sounds.playSE(FDBSound.SE_REFLEX);
	}
	private void wallReflexRight(int fieldWidth,FDBSound sounds){
		if(addX!=0){
			addY=(int)(addY*(fieldWidth-radiusNow-posX)/addX);
			addX=fieldWidth-radiusNow-posX;
		}else{	//[Z΍iʏ͋NȂ͂j
			addY=addX;
		}
		angle=calculateReflectAngle(angle,Math.PI);
		//
		sounds.playSE(FDBSound.SE_REFLEX);
	}
	private void wallReflexUp(FDBSound sounds){
		if(addY!=0){
			addX=(int)(addX*(radiusNow-posY)/addY);
			addY=radiusNow-posY;
		}else{	//[Z΍iʏ͋NȂ͂j
			addX=addY;
		}
		angle=calculateReflectAngle(angle,Math.PI/2);
		//
		sounds.playSE(FDBSound.SE_REFLEX);
	}
	private void wallReflexDown(int fieldHeight,FDBSound sounds){
		if(addY!=0){
			addX=(int)(addX*(fieldHeight-radiusNow-posY)/addY);
			addY=fieldHeight-radiusNow-posY;
		}else{	//[Z΍iʏ͋NȂ͂j
			addX=addY;
		}
		angle=calculateReflectAngle(angle,Math.PI*3/2);
		//
		sounds.playSE(FDBSound.SE_REFLEX);
	}
	//o[iǂł͂ȂjƂ̓蔻itrueԂj
	private boolean checkBarTouch(int ballX,int ballY,int barX,int barY,int touchRadius,FDBSound sounds){
		int distX=ballX-barX;
		int distY=ballY-barY;
		double distNow=Math.sqrt(Math.pow(distX,2)+Math.pow(distY,2));
		//~̒S_Ԃ̋Ŕ
		if(distNow<=touchRadius){
			//iH̐mȐړ_ł͂ȂAȗɂ
			if(distNow!=0){
				addX=(int)(barX+distX*touchRadius/distNow-posX);
				addY=(int)(barY+distY*touchRadius/distNow-posY);
				angle=calculateReflectAngle(angle,Math.atan2(distY,distX));
			}else{	//[Z΍iXs[hɂ͂肤AƑĒʂ蔲Ƃ́Hj
				addX=(int)(addX*(speedNow-touchRadius)/speedNow);
				addY=(int)(addY*(speedNow-touchRadius)/speedNow);
				angle=controlAngle(angle+Math.PI);
			}
			//R{Zbg
			combo=0;
			//
			sounds.playSE(FDBSound.SE_REFLEX);
			//
			return true;
		}else{
			return false;
		}
	}
	//***************************ȉ͐ÓI\bh*************************
	//-----------------------
	//݂̊pxƔˊpAˌ̊pxZoiItem̕ǔ˂ɂgj
	//-----------------------
	public static double calculateReflectAngle(double angleBefore,double reflectBaseAngle){
		//
		double relativeAngle=controlRelativeAngle(reflectBaseAngle-angleBefore);
		if(relativeAngle>=0){
			return controlAngle(angleBefore+2*(relativeAngle-Math.PI/2));
		}else{
			return controlAngle(angleBefore+2*(relativeAngle+Math.PI/2));
		}
	}
	//px0`2PIɕۂ
	private static double controlAngle(double angleBefore){
		double angleAfter=angleBefore;
		if(angleAfter<0){
			do{
				angleAfter+=Math.PI*2;
			}while(angleAfter<0);
		}else if(angleAfter>=Math.PI*2){
			do{
				angleAfter-=Math.PI*2;
			}while(angleAfter>=Math.PI*2);
		}
		return angleAfter;
	}
	//---------------------------
	//Ίp-PI`PI
	//---------------------------
	private static double controlRelativeAngle(double relativeAngle){
		if(relativeAngle>Math.PI){
			return relativeAngle-Math.PI*2;	//do-while
		}else if(relativeAngle<-Math.PI){
			return relativeAngle+Math.PI*2;
		}else{
			return relativeAngle;
		}
	}
}
