import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
//import javax.swing.filechooser.FileNameExtensionFilter;


public class FDBBlockDialog extends JDialog implements ActionListener,ListSelectionListener, WindowListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	private static final int L_ALL=0;
	private static final int L_DEFAULT=1;
	private static final int L_FIRSTSTAGE=2;
	//Ăяo
	FDBFrame frame;
	FDBFileIO fileIO;
	//
	DefaultListModel listModelStage=new DefaultListModel();
	JList listStage=new JList(listModelStage);
	//
	JButton buttonDelete=new JButton("w폜");
	JButton buttonFolder=new JButton("tH_I");
	JButton buttonFile=new JButton("t@CI");
	JButton buttonEnd=new JButton("I");
	//List̒PƑÎ
	int selected;
	//*************************************************************
	//
	//-------------------------------------------------------------
	public FDBBlockDialog(FDBFrame frm,FDBFileIO fIO){
		super(frm,"ubNwt@Cǂݍ",true);
		//
		frame=frm;
		fileIO=fIO;
		//
		makeStageList(FDBFrame.STAGE_MAX);
		//
		JPanel panelStage=new JPanel();
		JScrollPane scPanel=new JScrollPane(listStage);
		scPanel.setPreferredSize(new Dimension(150,150));
		panelStage.add(scPanel);
		//
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonDelete);
		panelBtn.add(buttonFolder);
		panelBtn.add(buttonFile);
		panelBtn.add(buttonEnd);
		//
		setLayout(new BorderLayout());
		add(panelStage,BorderLayout.CENTER);
		add(panelBtn,BorderLayout.SOUTH);
		//ẽCxg
		listStage.addListSelectionListener(this);
		buttonDelete.addActionListener(this);
		buttonFolder.addActionListener(this);
		buttonFile.addActionListener(this);
		buttonEnd.addActionListener(this);
		addWindowListener(this);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//*************************************************************
	//Xg
	//-------------------------------------------------------------
	//S̍쐬i\OɁj
	private void makeStageList(int num){
		//
		listModelStage.clear();
		//
		listModelStage.addElement("܂Ƃ߂Ďw");
		listModelStage.addElement("default"+fileIO.checkFileInWorkFolder(FDBFileIO.getTargetBlockFileName(0)));
		for(int n=1;n<=num;n++){
			listModelStage.addElement("stage "+n+fileIO.checkFileInWorkFolder(FDBFileIO.getTargetBlockFileName(n)));
		}
		//
		listStage.setSelectedIndex(0);
		selected=0;
		//
		enableSelectButton();
	}
	//ڂĐݒif[^폜ۑɁj
	private void changeSelectedListElement(){
		if(selected==L_ALL){
			//
		}else if(selected==L_DEFAULT){
			listModelStage.set(0,"default"+fileIO.checkFileInWorkFolder(FDBFileIO.getTargetBlockFileName(0)));
		}else{
			listModelStage.set(selected,"stage "+(selected-L_DEFAULT)+fileIO.checkFileInWorkFolder(FDBFileIO.getTargetBlockFileName(selected-L_DEFAULT)));
		}
	}
	//*************************************************************
	//_CAO\Ȍ
	//-------------------------------------------------------------
	public void setLatestData(int stg){
		//Xg쐬
		makeStageList(stg);
	}
	//*************************************************************
	//Cxg
	//-------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {		//Button
		Object object=e.getSource();
		if(object==buttonDelete){
			//wt@C폜
			fileIO.deleteBlockFile(selected-L_DEFAULT);			//Xe[WԍvZ
			//XgڂĐݒ
			changeSelectedListElement();
			//ݒύXʒm
			fileIO.changePuzzle(false);
		}else if(object==buttonFolder){		//all stages
			File folder=fileIO.chooseFolder("ubNzutH_I", "I", null);
			if(folder!=null){
				int stg=listModelStage.getSize()-L_FIRSTSTAGE;	//Xe[WvZ
				//Ovzut@Ĉ݂ƃtH_ɃRs[iƃtH_̂폜͂Ȃj
				fileIO.copyBlockFiles(folder, stg);
				//Xgڂ̑SĂĐݒ
				makeStageList(stg);
				//ݒύXʒm
				fileIO.changePuzzle(false);
			}
		}else if(object==buttonFile){		//selected stage
			File file=fileIO.chooseFileOnLoad("ubNzut@C(*.csv)I","I",null/*,new FileNameExtensionFilter("ubNzut@C(*.csv)","csv")*/);
			if(file!=null){
				//̃Xe[W̔zut@CƂăRs[it@C͓KXύXj
				fileIO.copyBlockFile(selected-L_DEFAULT, file);	//Xe[WԍvZ
				//XgڂĐݒ
				changeSelectedListElement();
				//ݒύXʒm
				fileIO.changePuzzle(false);
			}
		}else if(object==buttonEnd){
			//_CAOۂɂ͕KpYăX^[giݒ肪ύXĂ邩Ȃj
			frame.restartPuzzle(true);
			//
			setVisible(false);
		}
	}
	public void valueChanged(ListSelectionEvent e) {	//List
		//PƑIłȂ悤ɂ
		int f=listStage.getMinSelectionIndex();
		int l=listStage.getMaxSelectionIndex();
		if(f==selected){
			listStage.setSelectedIndex(l);
			selected=l;
		}else{
			listStage.setSelectedIndex(f);
			selected=f;
		}
		//
		enableSelectButton();
	}
	//****************************************************************************
	//windowCxg
	//----------------------------------------------------------------------------
	public void windowActivated(WindowEvent arg0) {
	}
	public void windowClosed(WindowEvent arg0) {
	}
	public void windowClosing(WindowEvent arg0) {
		frame.restartPuzzle(true);	//_CAOۂɂ͕KpYăX^[giݒ肪ύXĂ邩Ȃj
	}
	public void windowDeactivated(WindowEvent arg0) {
	}
	public void windowDeiconified(WindowEvent arg0) {
	}
	public void windowIconified(WindowEvent arg0) {
	}
	public void windowOpened(WindowEvent arg0) {
	}
	//*************************************************************
	//
	//-------------------------------------------------------------
	private void enableSelectButton(){
		if(selected==L_ALL){
			buttonFolder.setEnabled(true);
			buttonFile.setEnabled(false);
		}else{
			buttonFolder.setEnabled(false);
			buttonFile.setEnabled(true);
		}
	}
}
