import java.awt.*;
import java.awt.image.*;

//gp摜SĂǗ
public class FDBImageSupply extends Component
{
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//------------------------------------------
	//Block̐F
	static final int WHITE=0;		//w
	static final int YELLOW=1;		//y
	static final int ORANGE=2;		//o
	static final int PINK=3;		//m
	static final int RED=4;			//r
	static final int BROWN=5;		//t
	static final int YELLOWGREEN=6;	//k
	static final int GREEN=7;		//g
	static final int LIGHTBLUE=8;	//l
	static final int BLUE=9;		//a
	static final int PURPLE=10;		//p
	static final int BLACK=11;		//b
	static final int NOCOLOR=12;	//n
	//--------------------------------
	//
	Image blockImages[][];
	Image itemImages[][];
	Image ballImage;
	Image barImage;
	Image backImage;
	int backWidth,backHeight;
	//----------------------------------------------
	//
	//----------------------------------------------
	public FDBImageSupply(FDBStageLoader stage,FDBBall ball,FDBBars bars,FDBPanelListener parent){
		//----------------------------------------------ubN쐬
		createBlockImage(parent);
		createItemImage(parent);
		//
		formatImages(stage,ball,bars,parent);
	}
	//RXgN^łȂXe[WłĂ΂
	public void formatImages(FDBStageLoader stage,FDBBall ball,FDBBars bars,FDBPanelListener parent){
		//
		if(stage.s1.backImage==null){
			ballImage=create3DCircleImage(ball.radiusNormal,ball.color,stage.s1.backColor);
			barImage=create3DCircleImage(bars.barRadiusNormal,bars.barColor,stage.s1.backColor);
		}else{
			ballImage=create3DCircleImage(ball.radiusNormal,ball.color,null);
			barImage=create3DCircleImage(bars.barRadiusNormal,bars.barColor,null);
		}
		//
		if(stage.s1.backImage==null){
			backImage=null;
		}else{
			backImage=parent.getImage(stage.s1.backImage);
			backWidth=backImage.getWidth(this);
			backHeight=backImage.getHeight(this);
		}
	}
	//---------------------------------
	//̓Iȋ̉摜쐬
	//----------------------------------
	private Image create3DCircleImage(int rad,Color col,Color backCol){
		//
		Image ret;
		//ł邢_
		int brightPointX=(int)(rad*2/3);
		int brightPointY=(int)(rad*2/3);
		//
		int[] circleImagePix=new int[(int)(Math.pow(rad*2,2))];
		float[] hsb=new float[3];
		//x
		for(int h=0;h<rad*2;h++){
			for(int w=0;w<rad*2;w++){
				if( Math.pow(w-rad,2)+Math.pow(h-rad,2)>Math.pow(rad/*-1*/,2) ){
					if(backCol!=null){
						circleImagePix[h*rad*2+w]=backCol.getRGB() & 0x00ffffff;
					}else{
						circleImagePix[h*rad*2+w]=0x00ffffff;
					}
				}else{
					Color.RGBtoHSB(col.getRed(),col.getGreen(),col.getBlue(),hsb);
					//
					hsb[2]-=Math.sqrt(Math.pow(w-brightPointX,2)+Math.pow(h-brightPointY,2))/(rad*2)-0.5;
					if(hsb[2]<0){
						hsb[2]=0;
					}else if(hsb[2]>1){
						hsb[2]=1;
					}
					circleImagePix[h*rad*2+w]=0xff000000 | Color.HSBtoRGB(hsb[0],hsb[1],hsb[2]);
				}
			}
		}
		//
		//wi摜ȂȂwiFŃA`GAVO
		if(backCol!=null){
			int rr,gg,bb;
			for(int h=0;h<rad*2;h++){
				for(int w=0;w<rad*2;w++){
					int r2=(int)(Math.pow(w-rad,2)+Math.pow(h-rad,2));
					if( r2<=Math.pow(rad,2) && r2>Math.pow(rad-1,2) ){
						rr=gg=bb=0;
						for(int y=-1;y<=1;y++){
							for(int x=-1;x<=1;x++){
								if( w+x>=0 && w+x<rad*2 && h+y>=0 && h+y<rad*2 ){
									rr+=(circleImagePix[(h+y)*rad*2+(w+x)] >> 16) & 0xff;
									gg+=(circleImagePix[(h+y)*rad*2+(w+x)] >> 8) & 0xff;
									bb+=(circleImagePix[(h+y)*rad*2+(w+x)] >> 0) & 0xff;
								}else{
									rr+=backCol.getRed();
									gg+=backCol.getGreen();
									bb+=backCol.getBlue();
								}
							}
						}
						//
						circleImagePix[h*rad*2+w]=(0xff << 24) | ((rr/9) << 16) | ((gg/9) << 8) | ((bb/9) << 0);
					}
				}
			}
		}
		/*
		//
		for(int h=0;h<rad*2;h++){
			for(int w=0;w<rad*2;w++){
				if( ((circleImagePix[h*rad*2+w] >> 24) & 0xff)!=0x00 ){
					circleImagePix[h*rad*2+w]=(circleImagePix[h*rad*2+w] & 0x00ffffff) | 0xcc000000;
				}
			}
		}
		*/
		//摜쐬
		MemoryImageSource mis;
		mis=new MemoryImageSource(rad*2,rad*2,circleImagePix,0,rad*2);
		ret=createImage(mis);
		//I҂
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(ret, 0);
		try{
			mt.waitForID(0);
		}catch(InterruptedException e){}
		//
		return ret;
	}
	//---------------------------------
	//Block̉摜[h
	//----------------------------------
	private void createBlockImage(FDBPanelListener parent){
		//
		String folderName="image/block_";
		String fileName[]=new String[]{
								"w","y","o","m","r","t","k","g","l","a","p","b",
								};
		String extName=".gif";
		blockImages=new Image[NOCOLOR][4];
		//
		for(int c=0;c<NOCOLOR;c++){
			for(int a=0;a<4;a++){
				//
				blockImages[c][a]=parent.getImage(folderName+fileName[c]+(a+1)+extName);
			}
		}
		//
	}
	//---------------------------------
	//Item̉摜[h
	//----------------------------------
	private void createItemImage(FDBPanelListener parent){
		//
		String folderName="image/item_";
		String fileName[][]=new String[][]{
								{"barlong","barshort"},
								{"ballbig","ballsmall"},
								{"speedup","speeddown"},
								{"blockhide","damy"},
								{"gothrough","damy"},
								{"keepin","damy"},
								{"lifeup","lifedown"},
								{"blockincrease","blockdecrease"},
								{"scoreup","scoredown"},
								{"ballincrease","damy"},
								};
		String extName=".gif";
		itemImages=new Image[FDBItem.I_MAX][FDBItem.I_PAIR_MAX];
		for(int i=0;i<FDBItem.I_MAX;i++){
			if(FDBItem.pairFlag[i]){
				//
				itemImages[i][FDBItem.I_PAIR_UP]=parent.getImage(folderName+fileName[i][FDBItem.I_PAIR_UP]+extName);
				//
				itemImages[i][FDBItem.I_PAIR_DOWN]=parent.getImage(folderName+fileName[i][FDBItem.I_PAIR_DOWN]+extName);
			}else{
				//
				itemImages[i][FDBItem.I_PAIR_MID]=parent.getImage(folderName+fileName[i][FDBItem.I_PAIR_MID]+extName);
			}
		}
		//
	}
}
