import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


public class FDBNumSizeDialog extends JDialog implements ChangeListener, ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	//Ăяo
	FDBFrame frame;
	FDBFileIO fileIO;
	//
	SpinnerNumberModel stageNum=new SpinnerNumberModel(1,1,FDBFrame.STAGE_MAX,1);
	SpinnerNumberModel puzzleWidth=new SpinnerNumberModel(600,400,null,10);
	SpinnerNumberModel puzzleHeight=new SpinnerNumberModel(500,300,null,10);
	//
	JTextField fieldWidth=new JTextField(3);
	JTextField fieldHeight=new JTextField(3);
	//
	JButton buttonOk=new JButton("");
	JButton buttonCancel=new JButton("");
	//
	boolean newPuzzle=false;	//VK쐬pitruejf[^ύXpifalsej
	//
	//*************************************************************
	//
	//-------------------------------------------------------------
	public FDBNumSizeDialog(FDBFrame frm,FDBFileIO fIO){
		super(frm,"*****",true);
		//
		frame=frm;
		fileIO=fIO;
		//
		fieldWidth.setEditable(false);
		fieldHeight.setEditable(false);
		//
		JPanel panelNum=new JPanel();
		panelNum.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"Xe[W("+FDBFrame.STAGE_MAX+"܂)"));	//g
		panelNum.add(new JSpinner(stageNum));
		//
		JPanel panelPuzzleSize=new JPanel();
		panelPuzzleSize.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"S̃TCYi400~300ȏj"));	//g
		panelPuzzleSize.add(new JLabel(""));
		panelPuzzleSize.add(new JSpinner(puzzleWidth));
		panelPuzzleSize.add(new JLabel("~c"));
		panelPuzzleSize.add(new JSpinner(puzzleHeight));
		panelPuzzleSize.add(new JLabel("sNZ"));
		//
		JPanel panelFieldSize=new JPanel();
		panelFieldSize.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"tB[h̃TCY(vZ)"));	//g
		panelFieldSize.add(new JLabel(""));
		panelFieldSize.add(fieldWidth);
		panelFieldSize.add(new JLabel("~c"));
		panelFieldSize.add(fieldHeight);
		panelFieldSize.add(new JLabel("sNZ"));
		//
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonOk);
		panelBtn.add(buttonCancel);
		//
		JPanel panelSet=new JPanel();
		panelSet.setLayout(new GridLayout(3,1));
		panelSet.add(panelNum);
		panelSet.add(panelPuzzleSize);
		panelSet.add(panelFieldSize);
		//
		setLayout(new BorderLayout());
		add(panelSet,BorderLayout.CENTER);
		add(panelBtn,BorderLayout.SOUTH);
		//f[^̏Ԃʂɔf
		calcWholeSize();	//tB[h̃TCYvZ
		//ẽCxg
		puzzleWidth.addChangeListener(this);
		puzzleHeight.addChangeListener(this);
		//
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//*************************************************************
	//_CAO\Ȍ
	//-------------------------------------------------------------
	//VK쐬if[^j
	public void formatData(){
		stageNum.setValue(1);
		puzzleWidth.setValue(600);
		puzzleHeight.setValue(500);
		calcWholeSize();	//tB[h̃TCYvZ
		//
		newPuzzle=true;
		setTitle("VK쐬");
	}
	//ݒύXĩ݂f[^𓖂Ă͂߁j
	public void setLatestData(int stg,Dimension size){
		stageNum.setValue(stg);
		puzzleWidth.setValue(size.width);
		puzzleHeight.setValue(size.height);
		calcWholeSize();	//tB[h̃TCYvZ
		//
		newPuzzle=false;
		setTitle("Xe[WETCY");
	}
	//*************************************************************
	//Cxg
	//-------------------------------------------------------------
	public void stateChanged(ChangeEvent e) {		//Spinner
		calcWholeSize();	//ǂꂩςSČvZȂƂɂ
	}
	public void actionPerformed(ActionEvent e) {	//Button
		Object object=e.getSource();
		if(object==buttonOk){
			//VK쐬ȂȑO̐ݒt@CS폜
			if(newPuzzle){
				fileIO.deleteWorkFiles();
			}
			//Xe[W̃ftHgݒt@C
			int stg=Integer.parseInt(stageNum.getValue().toString());
			frame.changeDefaultSetting(stg,newPuzzle);
			//{ݒt@C
			int w=Integer.parseInt(puzzleWidth.getValue().toString());
			int h=Integer.parseInt(puzzleHeight.getValue().toString());
			frame.changeBaseSetting(new Dimension(w,h),newPuzzle);
			//ݒύXʒm
			fileIO.changePuzzle(newPuzzle);
			//pYăX^[g
			frame.restartPuzzle(true);
			//
			setVisible(false);
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//*************************************************************
	//tB[h̃TCYvZ
	//-------------------------------------------------------------
	private void calcWholeSize(){			//vZďo
		int w=Integer.parseInt(puzzleWidth.getValue().toString());
		int h=Integer.parseInt(puzzleHeight.getValue().toString());
		//
		fieldWidth.setText(""+(w-FDBPanel.U15*2));
		fieldHeight.setText(""+(h-FDBPanel.U75-FDBPanel.U15*3));
	}
}
