import java.awt.Color;
import java.net.URL;


public class FDBSetFile {
	//
	//---------------------------------
	//Xe[WisBallpw肷l
	static final int BALL_CONTINUE_IN=-2;	//vOpi0͓Ŏgp邽ߎgȂj
	static final int BALL_CONTINUE_OUT=0;	//Õ[U[wp
	//---------------------------------
	//
	static final String L_STAGE_MAX="stage_max";
	static final String L_STAGE_START="stage_start";
	static final String L_STAGE_CONTINUE="stage_continue";
	static final String L_PREMIUM_PAGE="premium_page";
	static final String L_LIFEUP_SCORE="lifeup_score";
	static final String L_BALL_COUNT="ball_count";
	static final String L_BALL_SPEED="ball_speed";
	static final String L_BALL_RADIUS="ball_radius";
	static final String L_BALL_COLOR="ball_color";
	static final String L_POWER_EFFECT="power_effect";
	static final String L_BARS_LENGTH="bar_length";
	static final String L_BARS_COLOR="bar_color";
	static final String L_BARS_OVERHANG="bar_overhang";
	static final String L_DIRECTION_UP="direction_up";
	static final String L_DIRECTION_DOWN="direction_down";
	static final String L_DIRECTION_LEFT="direction_left";
	static final String L_DIRECTION_RIGHT="direction_right";
	static final String L_BACK_COLOR="back_color";
	static final String L_BACK_IMAGE="back_image";
	static final String L_CLEAR_RATE="clear_rate";
	static final String L_FRONT_LINE="front_line";
	static final String L_ITEM_RATE="item_rate";
	static final String L_ITEM_BARLONG="item_barlong";
	static final String L_ITEM_BARSHORT="item_barshort";
	static final String L_ITEM_BALLBIG="item_ballbig";
	static final String L_ITEM_BALLSMALL="item_ballsmall";
	static final String L_ITEM_SPEEDUP="item_speedup";
	static final String L_ITEM_SPEEDDOWN="item_speeddown";
	static final String L_ITEM_LIFEUP="item_lifeup";
	static final String L_ITEM_LIFEDOWN="item_lifedown";
	static final String L_ITEM_BLOCKINCREASE="item_blockincrease";
	static final String L_ITEM_BLOCKDECREASE="item_blockdecrease";
	static final String L_ITEM_SCOREUP="item_scoreup";
	static final String L_ITEM_SCOREDOWN="item_scoredown";
	static final String L_ITEM_BLOCKHIDE="item_blockhide";
	static final String L_ITEM_GOTHROUGH="item_gothrough";
	static final String L_ITEM_KEEPIN="item_keepin";
	static final String L_ITEM_BALLINCREASE="item_ballincrease";
	//
	static final int V_STAGE_MAX=1;
	static final int V_STAGE_START=1;
	static final boolean V_STAGE_CONTINUE=true;
	static final String V_PREMIUM_PAGE=null;
	static final int V_LIFEUP_SCORE=500;
	static final int V_BALL_COUNT=5;
	static final int V_BALL_SPEED=15;
	static final int V_BALL_RADIUS=10;
	static final Color V_BALL_COLOR=Color.white;
	static final int V_POWER_EFFECT=5;
	static final int V_BARS_LENGTH=100;
	static final Color V_BARS_COLOR=Color.white;
	static final int V_BARS_OVERHANG=15;
	static final boolean V_DIRECTION_UP=false;
	static final boolean V_DIRECTION_DOWN=false;
	static final boolean V_DIRECTION_LEFT=false;
	static final boolean V_DIRECTION_RIGHT=false;
	static final Color V_BACK_COLOR=Color.black;
	static final String V_BACK_IMAGE=null;
	static final int V_CLEAR_RATE=100;
	static final int V_FRONT_LINE=V_BALL_RADIUS*3;
	static final int V_ITEM_RATE=15;
	static final int V_ITEM_BARLONG=6;
	static final int V_ITEM_BARSHORT=6;
	static final int V_ITEM_BALLBIG=6;
	static final int V_ITEM_BALLSMALL=6;
	static final int V_ITEM_SPEEDUP=6;
	static final int V_ITEM_SPEEDDOWN=6;
	static final int V_ITEM_LIFEUP=2;
	static final int V_ITEM_LIFEDOWN=2;
	static final int V_ITEM_BLOCKINCREASE=2;
	static final int V_ITEM_BLOCKDECREASE=2;
	static final int V_ITEM_SCOREUP=2;
	static final int V_ITEM_SCOREDOWN=2;
	static final int V_ITEM_BLOCKHIDE=1;
	static final int V_ITEM_GOTHROUGH=1;
	static final int V_ITEM_KEEPIN=1;
	static final int V_ITEM_BALLINCREASE=1;
	//
	//---------------------------------
	//
	FDBPanelListener listener;
	//---------------------------------S
	//GeneralState
	int gStageMax;
	int gStageStart;
	boolean gStageContinue;
	//
	String gPremiumPage;
	//---------------------------------ʁiftHgj
	//GeneralState
	int lifeupScore;
	//Ball
	int ballCount;
	int ballSpeed;
	int ballRadius;
	Color ballColor;
	//
	int powerEffect;
	//Bars
	int barsLength;
	Color barsColor;
	int barsOverhang;
	//
	boolean direction[];
	//ImageSupply
	Color backColor;
	String backImage;
	//Blocks
	int clearRate;
	int frontLine;
	//Item
	int itemRate;
	int itemRatio[][];
	//-----------------------------------
	//ݒt@C̕񂩂KvȒloi[Ăꎞϐ
	String tmpName;
	String tmpValueString;
	int tmpValueInt;
	Color tmpValueColor;
	boolean tmpValueBoolean;
	//*******************************************
	//
	//------------------------------------------
	public FDBSetFile(FDBPanelListener field){
		listener=field;
	}
	//*******************************************
	//Appletł̂܂y[W
	//------------------------------------------
	public URL getPremiumPageURL(){
		return listener.changeToURL(gPremiumPage);
	}
	//*******************************************
	//ۑt@C̕󂯎A߂ăf[^Ƃĕێ
	//------------------------------------------
	//ftHg
	public void setDefaultData(String[] data){
		//
		//::::vȌlݒ::::
		//-------------------------S
		//GeneralState
		gStageMax=V_STAGE_MAX;
		gStageStart=V_STAGE_START;
		gStageContinue=V_STAGE_CONTINUE;
		//
		gPremiumPage=V_PREMIUM_PAGE;
		//-------------------------ʁiftHgj
		//GeneralState
		lifeupScore=V_LIFEUP_SCORE;
		//Ball
		ballCount=V_BALL_COUNT;
		ballSpeed=V_BALL_SPEED;
		ballRadius=V_BALL_RADIUS;
		ballColor=V_BALL_COLOR;
		//
		powerEffect=V_POWER_EFFECT;
		//Bars
		barsLength=V_BARS_LENGTH;
		barsColor=V_BARS_COLOR;
		barsOverhang=V_BARS_OVERHANG;
		//
		direction=new boolean[FDBBars.D_ALL];
		direction[FDBBars.D_UP]=V_DIRECTION_UP;
		direction[FDBBars.D_DOWN]=V_DIRECTION_DOWN;
		direction[FDBBars.D_LEFT]=V_DIRECTION_LEFT;
		direction[FDBBars.D_RIGHT]=V_DIRECTION_RIGHT;
		//ImageSupply
		backColor=V_BACK_COLOR;
		backImage=V_BACK_IMAGE;
		//Blocks
		clearRate=V_CLEAR_RATE;
		frontLine=V_FRONT_LINE;
		//Item
		itemRate=V_ITEM_RATE;
		itemRatio=new int[FDBItem.I_MAX][FDBItem.I_PAIR_MAX];
		itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_UP]=V_ITEM_BARLONG;
		itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_DOWN]=V_ITEM_BARSHORT;
		itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_UP]=V_ITEM_BALLBIG;
		itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_DOWN]=V_ITEM_BALLSMALL;
		itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_UP]=V_ITEM_SPEEDUP;
		itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_DOWN]=V_ITEM_SPEEDDOWN;
		itemRatio[FDBItem.I_TIME_MONO_BLOCKVIEW][FDBItem.I_PAIR_MID]=V_ITEM_BLOCKHIDE;
		itemRatio[FDBItem.I_TIME_MONO_THROUGH][FDBItem.I_PAIR_MID]=V_ITEM_GOTHROUGH;
		itemRatio[FDBItem.I_TIME_MONO_REFLEX][FDBItem.I_PAIR_MID]=V_ITEM_KEEPIN;
		itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_UP]=V_ITEM_LIFEUP;
		itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_DOWN]=V_ITEM_LIFEDOWN;
		itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_UP]=V_ITEM_BLOCKINCREASE;
		itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_DOWN]=V_ITEM_BLOCKDECREASE;
		itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_UP]=V_ITEM_SCOREUP;
		itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_DOWN]=V_ITEM_SCOREDOWN;
		itemRatio[FDBItem.I_ONCE_MONO_DIVIDE][FDBItem.I_PAIR_MID]=V_ITEM_BALLINCREASE;
		//
		//::::ݒt@C̏lǂݍ::::
		if(data.length>0){
			//
			for(int i=0;i<data.length;i++){
				if(takeoutDataToString(data[i])){
					if(tmpName.equals(L_STAGE_MAX)){
						if(changeStringToInt(tmpValueString)){	gStageMax=tmpValueInt;	}
					}else if(tmpName.equals(L_STAGE_START)){
						if(changeStringToInt(tmpValueString)){	gStageStart=tmpValueInt;	}
					}else if(tmpName.equals(L_STAGE_CONTINUE)){
						if(changeStringToBoolean(tmpValueString)){	gStageContinue=tmpValueBoolean;	}
					}else if(tmpName.equals(L_PREMIUM_PAGE)){
						gPremiumPage=tmpValueString;
					}else if(tmpName.equals(L_LIFEUP_SCORE)){
						if(changeStringToInt(tmpValueString)){	lifeupScore=tmpValueInt;	}
					}else if(tmpName.equals(L_BALL_COUNT)){
						if(changeStringToInt(tmpValueString)){	ballCount=tmpValueInt;	}
					}else if(tmpName.equals(L_BALL_SPEED)){
						if(changeStringToInt(tmpValueString)){	ballSpeed=tmpValueInt;	}
					}else if(tmpName.equals(L_BALL_RADIUS)){
						if(changeStringToInt(tmpValueString)){	ballRadius=tmpValueInt;	}
					}else if(tmpName.equals(L_BALL_COLOR)){
						if(changeStringToColor(tmpValueString)){	ballColor=tmpValueColor;	}
					}else if(tmpName.equals(L_POWER_EFFECT)){
						if(changeStringToInt(tmpValueString)){	powerEffect=tmpValueInt;	}
					}else if(tmpName.equals(L_BARS_LENGTH)){
						if(changeStringToInt(tmpValueString)){	barsLength=tmpValueInt;	}
					}else if(tmpName.equals(L_BARS_COLOR)){
						if(changeStringToColor(tmpValueString)){	barsColor=tmpValueColor;	}
					}else if(tmpName.equals(L_BARS_OVERHANG)){
						if(changeStringToInt(tmpValueString)){	barsOverhang=tmpValueInt;	}
					}else if(tmpName.equals(L_DIRECTION_UP)){
						if(changeStringToBoolean(tmpValueString)){	direction[FDBBars.D_UP]=tmpValueBoolean;	}
					}else if(tmpName.equals(L_DIRECTION_DOWN)){
						if(changeStringToBoolean(tmpValueString)){	direction[FDBBars.D_DOWN]=tmpValueBoolean;	}
					}else if(tmpName.equals(L_DIRECTION_LEFT)){
						if(changeStringToBoolean(tmpValueString)){	direction[FDBBars.D_LEFT]=tmpValueBoolean;	}
					}else if(tmpName.equals(L_DIRECTION_RIGHT)){
						if(changeStringToBoolean(tmpValueString)){	direction[FDBBars.D_RIGHT]=tmpValueBoolean;	}
					}else if(tmpName.equals(L_BACK_COLOR)){
						if(changeStringToColor(tmpValueString)){	backColor=tmpValueColor;	}
					}else if(tmpName.equals(L_BACK_IMAGE)){
						backImage=tmpValueString;
					}else if(tmpName.equals(L_CLEAR_RATE)){
						if(changeStringToInt(tmpValueString)){	clearRate=tmpValueInt;	}
					}else if(tmpName.equals(L_FRONT_LINE)){
						if(changeStringToInt(tmpValueString)){	frontLine=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_RATE)){
						if(changeStringToInt(tmpValueString)){	itemRate=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BARLONG)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BARSHORT)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BALLBIG)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BALLSMALL)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_SPEEDUP)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_SPEEDDOWN)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_LIFEUP)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_LIFEDOWN)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BLOCKINCREASE)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BLOCKDECREASE)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_SCOREUP)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_SCOREDOWN)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BLOCKHIDE)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_MONO_BLOCKVIEW][FDBItem.I_PAIR_MID]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_GOTHROUGH)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_MONO_THROUGH][FDBItem.I_PAIR_MID]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_KEEPIN)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_MONO_REFLEX][FDBItem.I_PAIR_MID]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BALLINCREASE)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_MONO_DIVIDE][FDBItem.I_PAIR_MID]=tmpValueInt;	}
					}
				}
			}
			//ʒ
			if(lifeupScore<0){
				lifeupScore=0;	//o[W-1wɂȂĂւ̑Ή
			}
			if(ballCount==BALL_CONTINUE_OUT){
				ballCount=V_BALL_COUNT;		//ftHglupvł͂Ȃ
			}
			if(frontLine<3*ballRadius){
				frontLine=3*ballRadius;
			}
			if(clearRate<0){
				clearRate=0;
			}else if(clearRate>100){
				clearRate=100;
			}
		}
	}
	//eXe[W
	public void setStageData(String[] data,boolean ballFormatFlag,FDBSetFile def){
		//
		//::::炩ߏlK::::
		//GeneralState
		lifeupScore=def.lifeupScore;
		//Ball
		if(ballFormatFlag){
			ballCount=def.ballCount;
		}else{
			ballCount=BALL_CONTINUE_IN;
		}
		ballSpeed=def.ballSpeed;
		ballRadius=def.ballRadius;
		ballColor=def.ballColor;
		//
		powerEffect=def.powerEffect;
		//Bars
		barsLength=def.barsLength;
		barsColor=def.barsColor;
		barsOverhang=def.barsOverhang;
		//
		direction=new boolean[FDBBars.D_ALL];
		direction[FDBBars.D_UP]=def.direction[FDBBars.D_UP];
		direction[FDBBars.D_DOWN]=def.direction[FDBBars.D_DOWN];
		direction[FDBBars.D_LEFT]=def.direction[FDBBars.D_LEFT];
		direction[FDBBars.D_RIGHT]=def.direction[FDBBars.D_RIGHT];
		//ImageSupply
		backColor=def.backColor;
		backImage=def.backImage;
		//Blocks
		clearRate=def.clearRate;
		frontLine=def.frontLine;
		//Item
		itemRate=def.itemRate;
		itemRatio=new int[FDBItem.I_MAX][FDBItem.I_PAIR_MAX];
		for(int i=0;i<FDBItem.I_MAX;i++){
			for(int p=0;p<FDBItem.I_PAIR_MAX;p++){
				itemRatio[i][p]=def.itemRatio[i][p];
			}
		}
		//
		//::::Xe[Wݒǂݍ::::
		if(data.length>0){
			//
			for(int i=0;i<data.length;i++){
				if(takeoutDataToString(data[i])){
					if(tmpName.equals(L_LIFEUP_SCORE)){
						if(changeStringToInt(tmpValueString)){	lifeupScore=tmpValueInt;	}
					}else if(tmpName.equals(L_BALL_COUNT)){
						if(changeStringToInt(tmpValueString)){	ballCount=tmpValueInt;	}
					}else if(tmpName.equals(L_BALL_SPEED)){
						if(changeStringToInt(tmpValueString)){	ballSpeed=tmpValueInt;	}
					}else if(tmpName.equals(L_BALL_RADIUS)){
						if(changeStringToInt(tmpValueString)){	ballRadius=tmpValueInt;	}
					}else if(tmpName.equals(L_BALL_COLOR)){
						if(changeStringToColor(tmpValueString)){	ballColor=tmpValueColor;	}
					}else if(tmpName.equals(L_POWER_EFFECT)){
						if(changeStringToInt(tmpValueString)){	powerEffect=tmpValueInt;	}
					}else if(tmpName.equals(L_BARS_LENGTH)){
						if(changeStringToInt(tmpValueString)){	barsLength=tmpValueInt;	}
					}else if(tmpName.equals(L_BARS_COLOR)){
						if(changeStringToColor(tmpValueString)){	barsColor=tmpValueColor;	}
					}else if(tmpName.equals(L_BARS_OVERHANG)){
						if(changeStringToInt(tmpValueString)){	barsOverhang=tmpValueInt;	}
					}else if(tmpName.equals(L_DIRECTION_UP)){
						if(changeStringToBoolean(tmpValueString)){	direction[FDBBars.D_UP]=tmpValueBoolean;	}
					}else if(tmpName.equals(L_DIRECTION_DOWN)){
						if(changeStringToBoolean(tmpValueString)){	direction[FDBBars.D_DOWN]=tmpValueBoolean;	}
					}else if(tmpName.equals(L_DIRECTION_LEFT)){
						if(changeStringToBoolean(tmpValueString)){	direction[FDBBars.D_LEFT]=tmpValueBoolean;	}
					}else if(tmpName.equals(L_DIRECTION_RIGHT)){
						if(changeStringToBoolean(tmpValueString)){	direction[FDBBars.D_RIGHT]=tmpValueBoolean;	}
					}else if(tmpName.equals(L_BACK_COLOR)){
						if(changeStringToColor(tmpValueString)){	backColor=tmpValueColor;	}
					}else if(tmpName.equals(L_BACK_IMAGE)){
						backImage=tmpValueString;
					}else if(tmpName.equals(L_CLEAR_RATE)){
						if(changeStringToInt(tmpValueString)){	clearRate=tmpValueInt;	}
					}else if(tmpName.equals(L_FRONT_LINE)){
						if(changeStringToInt(tmpValueString)){	frontLine=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_RATE)){
						if(changeStringToInt(tmpValueString)){	itemRate=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BARLONG)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BARSHORT)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BALLBIG)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BALLSMALL)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_SPEEDUP)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_SPEEDDOWN)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_LIFEUP)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_LIFEDOWN)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BLOCKINCREASE)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BLOCKDECREASE)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_SCOREUP)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_UP]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_SCOREDOWN)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_DOWN]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BLOCKHIDE)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_MONO_BLOCKVIEW][FDBItem.I_PAIR_MID]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_GOTHROUGH)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_MONO_THROUGH][FDBItem.I_PAIR_MID]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_KEEPIN)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_TIME_MONO_REFLEX][FDBItem.I_PAIR_MID]=tmpValueInt;	}
					}else if(tmpName.equals(L_ITEM_BALLINCREASE)){
						if(changeStringToInt(tmpValueString)){	itemRatio[FDBItem.I_ONCE_MONO_DIVIDE][FDBItem.I_PAIR_MID]=tmpValueInt;	}
					}
				}
			}
			//ʒ
			if(lifeupScore<0){
				lifeupScore=0;	//o[W-1wɂȂĂւ̑Ή
			}
			if(ballCount==BALL_CONTINUE_OUT){
				ballCount=BALL_CONTINUE_IN;		//upv̎wp̒lɕϊ
			}
			if(frontLine<3*ballRadius){
				frontLine=3*ballRadius;
			}
			if(clearRate<0){
				clearRate=0;
			}else if(clearRate>100){
				clearRate=100;
			}
		}
	}
	//nꂽʂ̌^ɕϊitrueԂAʂꎞϐɊi[j
	private boolean changeStringToBoolean(String data){
		if(data.equals("0")){
			tmpValueBoolean=false;
			return true;
		}else if(data.equals("1")){
			tmpValueBoolean=true;
			return true;
		}else{
			return false;
		}
	}
	private boolean changeStringToColor(String data){
		try{
			tmpValueColor = Color.decode("0x"+data);
			return true;
		}catch(NumberFormatException e){
			return false;
		}
	}
	private boolean changeStringToInt(String data){
		try{
			tmpValueInt = Integer.parseInt(data);
			return true;
		}catch(NumberFormatException e){
			return false;
		}
	}
	//ݒ蕶̃JbR݂̂oitrueԂAʂꎞϐɊi[j
	private boolean takeoutDataToString(String data){
		//JnJbRȂAw薼Ȃ
		int index1=data.indexOf('(');
		if(index1==-1 || index1==0){	return false;	}
		//JbRȂAJbR̒gȂ
		int index2=data.indexOf(')',index1);
		if(index2==-1 || index2==index1+1){	return false;	}
		//
		tmpName=data.substring(0,index1);
		tmpValueString=data.substring(index1+1,index2);
		return true;
	}
	//*******************************************
	//ۑp̕쐬
	//------------------------------------------
	//ftHgipɃXe[Ŵݎwj
	public String getFirstDefaultDataString(){
		StringBuffer buf=new StringBuffer();
		//
		addProperty(buf,gStageMax,V_STAGE_MAX,L_STAGE_MAX);
		//
		return buf.toString();
	}
	public static boolean checkFirstDefaultData(String[] data){	//p̃ftHgXe[Wݒt@Cǂ
		if(data.length>1){	//Xe[W̎wȂ珉p̃t@Cł
			return false;
		}else{
			return true;
		}
	}
	//ftHg
	public String getDefaultDataString(){
		StringBuffer buf=new StringBuffer();
		//
		//-------------------------S
		//GeneralState
		addProperty(buf,gStageMax,V_STAGE_MAX,L_STAGE_MAX);
		addProperty(buf,gStageStart,V_STAGE_START,L_STAGE_START);
		addProperty(buf,gStageContinue,V_STAGE_CONTINUE,L_STAGE_CONTINUE);
		buf.append(FDBFileIO.BR);
		addProperty(buf,gPremiumPage,V_PREMIUM_PAGE,L_PREMIUM_PAGE);
		buf.append(FDBFileIO.BR);
		//-------------------------ʁiftHgj
		//GeneralState
		addProperty(buf,lifeupScore,V_LIFEUP_SCORE,L_LIFEUP_SCORE);
		buf.append(FDBFileIO.BR);
		//Ball
		addProperty(buf,ballCount,V_BALL_COUNT,L_BALL_COUNT);	//{[̃ftHgݒ́AƓł
		addProperty(buf,ballSpeed,V_BALL_SPEED,L_BALL_SPEED);
		addProperty(buf,ballRadius,V_BALL_RADIUS,L_BALL_RADIUS);
		addProperty(buf,ballColor,V_BALL_COLOR,L_BALL_COLOR);
		buf.append(FDBFileIO.BR);
		addProperty(buf,powerEffect,V_POWER_EFFECT,L_POWER_EFFECT);
		buf.append(FDBFileIO.BR);
		//Bars
		addProperty(buf,barsLength,V_BARS_LENGTH,L_BARS_LENGTH);
		addProperty(buf,barsColor,V_BARS_COLOR,L_BARS_COLOR);
		addProperty(buf,barsOverhang,V_BARS_OVERHANG,L_BARS_OVERHANG);
		buf.append(FDBFileIO.BR);
		addProperty(buf,direction[FDBBars.D_UP],V_DIRECTION_UP,L_DIRECTION_UP);
		addProperty(buf,direction[FDBBars.D_DOWN],V_DIRECTION_DOWN,L_DIRECTION_DOWN);
		addProperty(buf,direction[FDBBars.D_LEFT],V_DIRECTION_LEFT,L_DIRECTION_LEFT);
		addProperty(buf,direction[FDBBars.D_RIGHT],V_DIRECTION_RIGHT,L_DIRECTION_RIGHT);
		buf.append(FDBFileIO.BR);
		//ImageSupply
		addProperty(buf,backColor,V_BACK_COLOR,L_BACK_COLOR);
		addProperty(buf,backImage,V_BACK_IMAGE,L_BACK_IMAGE);
		buf.append(FDBFileIO.BR);
		//Blocks
		addProperty(buf,clearRate,V_CLEAR_RATE,L_CLEAR_RATE);
		addProperty(buf,frontLine,V_FRONT_LINE,L_FRONT_LINE);
		buf.append(FDBFileIO.BR);
		//Item
		addProperty(buf,itemRate,V_ITEM_RATE,L_ITEM_RATE);
		buf.append(FDBFileIO.BR);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_UP],V_ITEM_BARLONG,L_ITEM_BARLONG);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_DOWN],V_ITEM_BARSHORT,L_ITEM_BARSHORT);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_UP],V_ITEM_BALLBIG,L_ITEM_BALLBIG);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_DOWN],V_ITEM_BALLSMALL,L_ITEM_BALLSMALL);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_UP],V_ITEM_SPEEDUP,L_ITEM_SPEEDUP);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_DOWN],V_ITEM_SPEEDDOWN,L_ITEM_SPEEDDOWN);
		addProperty(buf,itemRatio[FDBItem.I_TIME_MONO_BLOCKVIEW][FDBItem.I_PAIR_MID],V_ITEM_BLOCKHIDE,L_ITEM_BLOCKHIDE);
		addProperty(buf,itemRatio[FDBItem.I_TIME_MONO_THROUGH][FDBItem.I_PAIR_MID],V_ITEM_GOTHROUGH,L_ITEM_GOTHROUGH);
		addProperty(buf,itemRatio[FDBItem.I_TIME_MONO_REFLEX][FDBItem.I_PAIR_MID],V_ITEM_KEEPIN,L_ITEM_KEEPIN);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_UP],V_ITEM_LIFEUP,L_ITEM_LIFEUP);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_DOWN],V_ITEM_LIFEDOWN,L_ITEM_LIFEDOWN);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_UP],V_ITEM_BLOCKINCREASE,L_ITEM_BLOCKINCREASE);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_DOWN],V_ITEM_BLOCKDECREASE,L_ITEM_BLOCKDECREASE);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_UP],V_ITEM_SCOREUP,L_ITEM_SCOREUP);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_DOWN],V_ITEM_SCOREDOWN,L_ITEM_SCOREDOWN);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_MONO_DIVIDE][FDBItem.I_PAIR_MID],V_ITEM_BALLINCREASE,L_ITEM_BALLINCREASE);
		//
		return buf.toString();
	}
	//eXe[W
	public String getStageDataString(FDBSetFile def){
		StringBuffer buf=new StringBuffer();
		//
		//GeneralState
		addProperty(buf,lifeupScore,def.lifeupScore,L_LIFEUP_SCORE);
		buf.append(FDBFileIO.BR);
		//Ball
		addProperty(buf,ballCount,FDBSetFile.BALL_CONTINUE_IN,L_BALL_COUNT);	//{[̃Xe[Wݒ́AupvwɂȂ
		addProperty(buf,ballSpeed,def.ballSpeed,L_BALL_SPEED);
		addProperty(buf,ballRadius,def.ballRadius,L_BALL_RADIUS);
		addProperty(buf,ballColor,def.ballColor,L_BALL_COLOR);
		buf.append(FDBFileIO.BR);
		addProperty(buf,powerEffect,def.powerEffect,L_POWER_EFFECT);
		buf.append(FDBFileIO.BR);
		//Bars
		addProperty(buf,barsLength,def.barsLength,L_BARS_LENGTH);
		addProperty(buf,barsColor,def.barsColor,L_BARS_COLOR);
		addProperty(buf,barsOverhang,def.barsOverhang,L_BARS_OVERHANG);
		buf.append(FDBFileIO.BR);
		addProperty(buf,direction[FDBBars.D_UP],def.direction[FDBBars.D_UP],L_DIRECTION_UP);
		addProperty(buf,direction[FDBBars.D_DOWN],def.direction[FDBBars.D_DOWN],L_DIRECTION_DOWN);
		addProperty(buf,direction[FDBBars.D_LEFT],def.direction[FDBBars.D_LEFT],L_DIRECTION_LEFT);
		addProperty(buf,direction[FDBBars.D_RIGHT],def.direction[FDBBars.D_RIGHT],L_DIRECTION_RIGHT);
		buf.append(FDBFileIO.BR);
		//ImageSupply
		addProperty(buf,backColor,def.backColor,L_BACK_COLOR);
		addProperty(buf,backImage,def.backImage,L_BACK_IMAGE);
		buf.append(FDBFileIO.BR);
		//Blocks
		addProperty(buf,clearRate,def.clearRate,L_CLEAR_RATE);
		addProperty(buf,frontLine,def.frontLine,L_FRONT_LINE);
		buf.append(FDBFileIO.BR);
		//Item
		addProperty(buf,itemRate,def.itemRate,L_ITEM_RATE);
		buf.append(FDBFileIO.BR);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_UP],def.itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_UP],L_ITEM_BARLONG);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_DOWN],def.itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_DOWN],L_ITEM_BARSHORT);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_UP],def.itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_UP],L_ITEM_BALLBIG);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_DOWN],def.itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_DOWN],L_ITEM_BALLSMALL);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_UP],def.itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_UP],L_ITEM_SPEEDUP);
		addProperty(buf,itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_DOWN],def.itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_DOWN],L_ITEM_SPEEDDOWN);
		addProperty(buf,itemRatio[FDBItem.I_TIME_MONO_BLOCKVIEW][FDBItem.I_PAIR_MID],def.itemRatio[FDBItem.I_TIME_MONO_BLOCKVIEW][FDBItem.I_PAIR_MID],L_ITEM_BLOCKHIDE);
		addProperty(buf,itemRatio[FDBItem.I_TIME_MONO_THROUGH][FDBItem.I_PAIR_MID],def.itemRatio[FDBItem.I_TIME_MONO_THROUGH][FDBItem.I_PAIR_MID],L_ITEM_GOTHROUGH);
		addProperty(buf,itemRatio[FDBItem.I_TIME_MONO_REFLEX][FDBItem.I_PAIR_MID],def.itemRatio[FDBItem.I_TIME_MONO_REFLEX][FDBItem.I_PAIR_MID],L_ITEM_KEEPIN);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_UP],def.itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_UP],L_ITEM_LIFEUP);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_DOWN],def.itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_DOWN],L_ITEM_LIFEDOWN);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_UP],def.itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_UP],L_ITEM_BLOCKINCREASE);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_DOWN],def.itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_DOWN],L_ITEM_BLOCKDECREASE);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_UP],def.itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_UP],L_ITEM_SCOREUP);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_DOWN],def.itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_DOWN],L_ITEM_SCOREDOWN);
		addProperty(buf,itemRatio[FDBItem.I_ONCE_MONO_DIVIDE][FDBItem.I_PAIR_MID],def.itemRatio[FDBItem.I_ONCE_MONO_DIVIDE][FDBItem.I_PAIR_MID],L_ITEM_BALLINCREASE);
		//
		return buf.toString();
	}
	//ۑpւ̍ڒǉPij
	private static void addProperty(StringBuffer buf,int value,int def,String lavel){
		if(value==def){
			buf.append(lavel).append("()").append(FDBFileIO.BR);
		}else{
			buf.append(lavel).append("(").append(value).append(")").append(FDBFileIO.BR);
		}
	}
	//ۑpւ̍ڒǉQi^Ulj
	private static void addProperty(StringBuffer buf,boolean value,boolean def,String lavel){
		if(value==def){
			buf.append(lavel).append("()").append(FDBFileIO.BR);
		}else{
			if(value){
				buf.append(lavel).append("(1)").append(FDBFileIO.BR);
			}else{
				buf.append(lavel).append("(0)").append(FDBFileIO.BR);
			}
		}
	}
	//ۑpւ̍ڒǉRij
	private static void addProperty(StringBuffer buf,String value,String def,String lavel){
		if(value==null){
			buf.append(lavel).append("()").append(FDBFileIO.BR);
		}else{
			if(def==null){
				buf.append(lavel).append("(").append(value).append(")").append(FDBFileIO.BR);
			}else{
				if(value.equals(def)){
					buf.append(lavel).append("()").append(FDBFileIO.BR);
				}else{
					buf.append(lavel).append("(").append(value).append(")").append(FDBFileIO.BR);
				}
			}
		}
	}
	//ۑpւ̍ڒǉSiFj
	private static void addProperty(StringBuffer buf,Color value,Color def,String lavel){
		if(value.equals(def)){
			buf.append(lavel).append("()").append(FDBFileIO.BR);
		}else{
			String v=Integer.toHexString(value.getRGB() & 0x00ffffff);	//At@[l16ił̕\
			buf.append(lavel).append("(").append(v).append(")").append(FDBFileIO.BR);
		}
	}
}
