import java.awt.*;
import java.util.*;

public class FDBBlocks
{
	//---------------------------------------------------
	//checkTouchBlock߂l
	static final int T_NO_TOUCH=0;
	static final int T_TOUCH=1;
	static final int T_TOUCH_UNBREAKABLE=2;
	static final int T_TOUCH_DECREASE=3;
	static final int T_TOUCH_BREAK_NOT_CLEAR=4;
	static final int T_TOUCH_BREAK_CLEAR=5;
	//---------------------------------------------------
	//c̃ubN
	int horizontalNum;
	int verticalNum;
	//ubNṕitB[h̑΁jW
	int cornerX[];
	int cornerY[];
	//Xe[WNA
	int restBreakableBlockStart;
	int restBreakableBlockNow;
	int clearBlockNum;
	//ubNzu
	int blockColor[][];
	int blockResistStart[][];
	int blockResistNow[][];
	//ڐGBall̕ύXlꎞi[
	int tmpAddX;
	int tmpAddY;
	double tmpReflectBaseAngle;
	//------------------------
	//
	//------------------------
	public FDBBlocks(FDBStageLoader stage,int fieldWidth,int fieldHeight){
		formatBlocks(stage,fieldWidth,fieldHeight);
	}
	//RXgN^łȂXe[WłĂ΂
	public void formatBlocks(FDBStageLoader stage,int fieldWidth,int fieldHeight){
		//
		StringTokenizer horizCut;
		int blockFieldStart,blockFieldSize;
		//c̃ubN
		horizCut=new StringTokenizer(stage.stageBlocksPlace[0],",");
		horizontalNum=horizCut.countTokens();
		verticalNum=stage.stageBlocksPlace.length;
		//ubNp̍Wiwj
		cornerX=new int[horizontalNum+1];
		if(stage.s1.direction[FDBBars.D_LEFT]){
			blockFieldStart=0;
		}else{
			blockFieldStart=stage.s1.barsOverhang+stage.s1.frontLine;
		}
		if(stage.s1.direction[FDBBars.D_RIGHT]){
			blockFieldSize=fieldWidth-blockFieldStart;
		}else{
			blockFieldSize=fieldWidth-stage.s1.barsOverhang-stage.s1.frontLine-blockFieldStart;
		}
		for(int h=0;h<=horizontalNum;h++){
			cornerX[h]=(int)(blockFieldStart+blockFieldSize*h/horizontalNum);
		}
		//ubNp̍Wixj
		cornerY=new int[verticalNum+1];
		if(stage.s1.direction[FDBBars.D_UP]){
			blockFieldStart=0;
		}else{
			blockFieldStart=stage.s1.barsOverhang+stage.s1.frontLine;
		}
		if(stage.s1.direction[FDBBars.D_DOWN]){
			blockFieldSize=fieldHeight-blockFieldStart;
			//all direction close
			if(stage.s1.direction[FDBBars.D_LEFT] && stage.s1.direction[FDBBars.D_RIGHT] && stage.s1.direction[FDBBars.D_UP]){
				blockFieldSize-=3*stage.s1.ballRadius;
			}
		}else{
			blockFieldSize=fieldHeight-stage.s1.barsOverhang-stage.s1.frontLine-blockFieldStart;
		}
		for(int v=0;v<=verticalNum;v++){
			cornerY[v]=(int)(blockFieldStart+blockFieldSize*v/verticalNum);
		}
		//͑OɏĂ
		restBreakableBlockStart=0;
		//ubNzu̔z
		blockColor=new int[horizontalNum][verticalNum];
		blockResistStart=new int[horizontalNum][verticalNum];
		blockResistNow=new int[horizontalNum][verticalNum];
		for(int h=0;h<horizontalNum;h++){
			for(int v=0;v<verticalNum;v++){
				blockColor[h][v]=FDBImageSupply.NOCOLOR;
				blockResistStart[h][v]=0;
				blockResistNow[h][v]=0;
			}
		}
		//ubNzu͂Aۂɔzu
		for(int v=0;v<verticalNum;v++){
			horizCut=new StringTokenizer(stage.stageBlocksPlace[v],",");
			for(int h=0;h<horizontalNum;h++){
				if(horizCut.hasMoreTokens()){
					analyzeBlockData(horizCut.nextToken(),h,v);
				}
			}
		}
		//Xe[WNA
		restBreakableBlockNow=restBreakableBlockStart;
		clearBlockNum=(int)(restBreakableBlockStart*(100-stage.s1.clearRate)/100);
	}
	//nꂽBlockf[^͂āAẅʒuɐݒ
	private void analyzeBlockData(String data,int h,int v){
		//f[^ԈႢ
		if(data.length()!=2){	return;	}
		//F
		String colorString=data.substring(0,1);
		if(colorString.equals("w")){
			blockColor[h][v]=FDBImageSupply.WHITE;
		}else if(colorString.equals("y")){
			blockColor[h][v]=FDBImageSupply.YELLOW;
		}else if(colorString.equals("o")){
			blockColor[h][v]=FDBImageSupply.ORANGE;
		}else if(colorString.equals("m")){
			blockColor[h][v]=FDBImageSupply.PINK;
		}else if(colorString.equals("r")){
			blockColor[h][v]=FDBImageSupply.RED;
		}else if(colorString.equals("t")){
			blockColor[h][v]=FDBImageSupply.BROWN;
		}else if(colorString.equals("k")){
			blockColor[h][v]=FDBImageSupply.YELLOWGREEN;
		}else if(colorString.equals("g")){
			blockColor[h][v]=FDBImageSupply.GREEN;
		}else if(colorString.equals("l")){
			blockColor[h][v]=FDBImageSupply.LIGHTBLUE;
		}else if(colorString.equals("a")){
			blockColor[h][v]=FDBImageSupply.BLUE;
		}else if(colorString.equals("p")){
			blockColor[h][v]=FDBImageSupply.PURPLE;
		}else if(colorString.equals("b")){
			blockColor[h][v]=FDBImageSupply.BLACK;
		}else if(colorString.equals("n")){
			blockColor[h][v]=FDBImageSupply.NOCOLOR;
		}
		//ϋv
		try{
			blockResistStart[h][v] = Integer.parseInt(data.substring(1,2));
			if(blockResistStart[h][v]>4){
				blockResistStart[h][v]=4;
			}
			blockResistNow[h][v]=blockResistStart[h][v];
			if(blockResistStart[h][v]>0 && blockResistStart[h][v]<4 && blockColor[h][v]!=FDBImageSupply.NOCOLOR){
				restBreakableBlockStart++;	//Xe[WNA
			}
		}catch(NumberFormatException e){}	//no change
	}
	//-----------------------
	//w肳ꂽʒuBlock͂邩
	//-----------------------
	public boolean checkBlockBeing(int h,int v){
		//͈͊O
		if(h<0 || h>=horizontalNum || v<0 || v>=verticalNum){
			return false;
		}
		//
		if(blockColor[h][v]==FDBImageSupply.NOCOLOR || blockResistNow[h][v]<=0){
			return false;
		}else{
			return true;
		}
	}
	//-----------------------
	//BallƍŏɐڂubN߁AڂړʂꎞϐɓAʂԂiBallmoveĂ΂j
	//-----------------------
	public int checkTouchBlock(int posX,int posY,int addX,int addY,int radius,FDBItemManager items){
		//łڂubN
		int touchBlockX=0;
		int touchBlockY=0;
		//߂luڂȂvŏĂ
		int ret=T_NO_TOUCH;
		//
		tmpAddX=addX;
		tmpAddY=addY;
		//is̈Ⴂz邽
		int fX,fY;
		if(addX>=0){	fX=1;	}else{	fX=-1;	}
		if(addY>=0){	fY=1;	}else{	fY=-1;	}
		//{[ړJn_ƈړI_̃ubN
		Point startBlockPos=getBlockPos(posX-fX*radius,posY-fY*radius);
		Point endBlockPos=getBlockPos(posX+addX+fX*(radius+1),posY+addY+fY*(radius+1));
		//{[ړBɂSubN`FbN
		for(int h=startBlockPos.x;((fX<0)?h>=endBlockPos.x:h<=endBlockPos.x);h+=fX){
			for(int v=startBlockPos.y;((fY<0)?v>=endBlockPos.y:v<=endBlockPos.y);v+=fY){
				if(checkBlockBeing(h,v)){	//̈ʒuɃubN
					int dX,dY;	//ubN̂̃CƐڂ_
					int pointX,pointY;	//ΏۂƂȂBlock̊p
					//
					//------
					if(addX!=0){
						dX=((fX<0)?cornerX[h+1]-1:cornerX[h])-(posX+fX*radius);
						dY=(int)(addY*dX/addX);	//dxɍ킹
						//ŸʒuŔ
						if(posY+dY<cornerY[v]){	//ubNȂÅpŐڂ邱ƂɂȂ
							pointY=cornerY[v];
						}else if(posY+dY>cornerY[v+1]-1){	//ubN艺ȂÅpŐڂ邱ƂɂȂ
							pointY=cornerY[v+1]-1;
						}else{	//ubNȂ
							//ړJn_OŐڂĂꍇꉞAOiN肦Ȃj
							if((fX<0)?dX<=0:dX>=0){	//uMath.abs(dX) <= Math.abs(addX)vĂiubN𔲂oĂj
								if(renewFasterData(dX,dY,(fX<0)?0:Math.PI,true)){	//̃ubN葁ڂĂ΁AK
									touchBlockX=h;
									touchBlockY=v;
									ret=T_TOUCH;	//߂lꎞIɁuڂvɂ
								}
								continue;	//ɐƃubNŐڂ̂ŁAƊp͔肵ȂĂ
							}else{	//already line overiɒʉ߂ĂA܂ubN͏Ă͂Ȃ̂ŋN肦Ȃj
								pointY=(fY<0)?cornerY[v+1]-1:cornerY[v];	//damy
							}
						}
					}else{	//ɈړĂ΁AƂ͐ڂȂ
						pointY=(fY<0)?cornerY[v+1]-1:cornerY[v];
					}
					//------
					if(addY!=0){
						dY=((fY<0)?cornerY[v+1]-1:cornerY[v])-(posY+fY*radius);
						dX=(int)(addX*dY/addY);	//dyɍ킹
						//ẌʒuŔ
						if(posX+dX<cornerX[h]){	//ubN荶ȂÅpŐڂ邱ƂɂȂ
							pointX=cornerX[h];
						}else if(posX+dX>cornerX[h+1]-1){	//ubNEȂAE̊pŐڂ邱ƂɂȂ
							pointX=cornerX[h+1]-1;
						}else{	//ubNȂ
							//ړJn_OŐڂĂꍇꉞAOiN肦Ȃj
							if((fY<0)?dY<=0:dY>=0){	//uMath.abs(dY) <= Math.abs(addY)vĂiubN𔲂oĂj
								if(renewFasterData(dX,dY,(fY<0)?Math.PI/2:Math.PI*3/2,true)){	//̃ubN葁ڂĂ΁AK
									touchBlockX=h;
									touchBlockY=v;
									ret=T_TOUCH;	//߂lꎞIɁuڂvɂ
								}
								continue;	//ɐƃubNŐڂ̂ŁAp͔肵ȂĂ
							}else{	//already line overiɒʉ߂ĂA܂ubN͏Ă͂Ȃ̂ŋN肦Ȃj
								pointX=(fX<0)?cornerX[h+1]-1:cornerX[h];	//damy
							}
						}
					}else{	//ɈړĂ΁AƂ͐ڂȂ
						pointX=(fX<0)?cornerX[h+1]-1:cornerX[h];
					}
					//---pỉ͂1_ɍiĂj---
					if(checkTouchPoint(pointX,pointY,posX,posY,addX,addY,radius)){
						touchBlockX=h;
						touchBlockY=v;
						ret=T_TOUCH;
					}
				}
			}
		}
		//
		if(ret==T_TOUCH){	//ڂꍇ
			if(blockResistNow[touchBlockX][touchBlockY]>=4){
				return T_TOUCH_UNBREAKABLE;	//jubN
			}else if(blockResistNow[touchBlockX][touchBlockY]>=1){
				//j\ubNȂϋv炷i{[ђʃACeȂŏj
				if(items.effectiveItemArr[FDBItem.I_TIME_MONO_THROUGH]==null){
					blockResistNow[touchBlockX][touchBlockY]--;
				}else{
					blockResistNow[touchBlockX][touchBlockY]=0;	//iȂ݂ɊpxύXȂABallŁj
				}
				//ubN΃Xe[WNA
				if(blockResistNow[touchBlockX][touchBlockY]==0){
					restBreakableBlockNow--;
					if(restBreakableBlockNow<=clearBlockNum){
						return T_TOUCH_BREAK_CLEAR;
					}else{
						return T_TOUCH_BREAK_NOT_CLEAR;
					}
				}else{
					return T_TOUCH_DECREASE;
				}
			}else{
				return T_NO_TOUCH;	//damyiN肦Ȃj
			}
		}else{	//ڂȂ΂̂܂܌ʂԂ
			return ret;
		}
	}
	//--------------------------------------
	//w̓_iBlock̊pjƂBallڂ邩iڂtrueԂj
	//---------------------------------------
	private boolean checkTouchPoint(int pointX,int pointY,int posX,int posY,int addX,int addY,int radius){
		if(addX!=0){
			//u(posX,posY)(posX+addX,posY+addY)ʂ钼vƁu_(pointX,pointY)aradius̉~v̌_
			//[y=ax+b],[r^2=x^2+y^2]i₷悤ɉ̍Wōlj
			//double a=addY/addX;	//vŽ덷ɂoOhߒڂɑ
			double b=(posY-pointY)-addY*(posX-pointX)/addX;	//b=y-ax
			//Ax^2+Bx+c=0iA߁A2ɂj
			double A=1+Math.pow(addY,2)/Math.pow(addX,2);	//A=1+a^2
			double B=2*addY*b/addX;							//B=2ab
			double C=Math.pow(b,2)-Math.pow(radius,2);		//C=b^2-r^2
			//2̉̌
			double inRoot=Math.pow(B,2)-4*A*C;			//B^2-4AC
			if(inRoot<0){	return false;	}	//Ȃ
			double ansX1=(-B+Math.sqrt(inRoot))/(2*A);	//x=(-B-B^2-4AC)/(2A)
			double ansX2=(-B-Math.sqrt(inRoot))/(2*A);	//x=(-B+B^2-4AC)/(2A)
			//{̍WɕϊČ_2߂
			int dX1=(int)(pointX+ansX1-posX);
			int dX2=(int)(pointX+ansX2-posX);
			int dY1=(int)(pointY+(ansX1*addY/addX+b)-posY);
			int dY2=(int)(pointY+(ansX2*addY/addX+b)-posY);
			//{[̈ړJn_I_̊Ԃɂ̌_͂邩iǂłXōlj
			if( ((addX<0)?dX1<=0:dX1>=0) && Math.abs(dX1)<=Math.abs(addX) ){
				if( ((addX<0)?dX2<=0:dX2>=0) && Math.abs(dX2)<=Math.abs(addX) ){
					if(Math.abs(dX1)<Math.abs(dX2)){	//̌_ĂāA_P̕
						return applyTouchPoint(pointX,pointY,posX,posY,dX1,dY1);
					}else{	//̌_ĂāA_Q̕
						return applyTouchPoint(pointX,pointY,posX,posY,dX2,dY2);
					}
				}else{	//_P݂̂Ă
					return applyTouchPoint(pointX,pointY,posX,posY,dX1,dY1);
				}
			}else{
				if( ((addX<0)?dX2<=0:dX2>=0) && Math.abs(dX2)<=Math.abs(addX) ){	//_Q݂̂Ă
					return applyTouchPoint(pointX,pointY,posX,posY,dX2,dY2);
				}else{	//̌_ĂȂ
					return false;
				}
			}
		}else{
			//ړĂȂΉ2֐̌_i[Zh߁j
			//[x=c],[r^2=x^2+y^2]
			int c=posX-pointX;
			//
			double inRoot=Math.pow(radius,2)-Math.pow(c,2);
			if(inRoot<0){	return false;	}
			//
			int dY1=(int)(pointY+Math.sqrt(inRoot)-posY);
			int dY2=(int)(pointY-Math.sqrt(inRoot)-posY);
			//iYōlȂ΂Ȃj
			if( ((addY<0)?dY1<=0:dY1>=0) && Math.abs(dY1)<=Math.abs(addY) ){
				if( ((addY<0)?dY2<=0:dY2>=0) && Math.abs(dY2)<=Math.abs(addY) ){
					if(Math.abs(dY1)<Math.abs(dY2)){
						return applyTouchPoint(pointX,pointY,posX,posY,0,dY1);
					}else{
						return applyTouchPoint(pointX,pointY,posX,posY,0,dY2);
					}
				}else{
					return applyTouchPoint(pointX,pointY,posX,posY,0,dY1);
				}
			}else{
				if( ((addY<0)?dY2<=0:dY2>=0) && Math.abs(dY2)<=Math.abs(addY) ){
					return applyTouchPoint(pointX,pointY,posX,posY,0,dY2);
				}else{
					return false;
				}
			}
		}
	}
	//pɓꍇAˊp߂ĂK˗i̗ptrueԂ邱ƂɂȂj
	private boolean applyTouchPoint(int pointX,int pointY,int posX,int posY,int dX,int dY){
		double reflectBaseAngle=Math.atan2(posY+dY-pointY,posX+dX-pointX);	//2_̍W甽ˊp߂
		return renewFasterData(dX,dY,reflectBaseAngle,false);	//̃ubN葁ڂĂ΁AK
	}
	//--------------
	//nꂽBallύXlŏ̐ړ_ɂȂȂ̗pi̗ptrueԂj
	//--------------
	private boolean renewFasterData(int dX,int dY,double reflectBaseAngle,boolean priorityFlag){
		if(Math.abs(dX)<Math.abs(tmpAddX) || Math.abs(dY)<Math.abs(tmpAddY)){
			tmpAddX=dX;
			tmpAddY=dY;
			tmpReflectBaseAngle=reflectBaseAngle;
			return true;
		}else if(Math.abs(dX)==Math.abs(tmpAddX) && Math.abs(dY)==Math.abs(tmpAddY)){
			if(priorityFlag){	//n_ȂpBD悳ijubN̕тł̃CM[ˑ΍􂾂As\Hj
				//tmpAddX=dX;
				//tmpAddY=dY;
				tmpReflectBaseAngle=reflectBaseAngle;	//ύX͊pxł
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}
	//--------------
	//nꂽtB[h̑΍ẂAǂ̈ʒuBlockɊ܂܂邩
	//--------------
	private Point getBlockPos(int posX,int posY){
		Point ret=new Point();
		//
		if(posX<cornerX[0]){
			ret.x=-1;
		}else if(posX>=cornerX[horizontalNum]){
			ret.x=horizontalNum;
		}else{
			ret.x=(int)((posX-cornerX[0])/(cornerX[1]-cornerX[0]));	//Ƃ肠̃ubNʒuvZi>= 0j
			if(ret.x>=horizontalNum-1){
				ret.x=horizontalNum-1;
			}
			if(cornerX[ret.x]>posX){
				do{
					ret.x--;
				}while(cornerX[ret.x]>posX);	//ɂĂ΂͂܂܂ŏCiret.x >= 0j
			}else if(cornerX[ret.x+1]<=posX){
				do{
					ret.x++;
				}while(cornerX[ret.x+1]<=posX);	//ɂĂ΂͂܂܂ŏCiret.x < horizontalNumj
			}
		}
		//c
		if(posY<cornerY[0]){
			ret.y=-1;
		}else if(posY>=cornerY[verticalNum]){
			ret.y=verticalNum;
		}else{
			ret.y=(int)((posY-cornerY[0])/(cornerY[1]-cornerY[0]));	//Ƃ肠̈ʒuvZi>= 0j
			if(ret.y>=verticalNum-1){
				ret.y=verticalNum-1;
			}
			if(cornerY[ret.y]>posY){
				do{
					ret.y--;
				}while(cornerY[ret.y]>posY);	//ɂĂ΂͂܂܂ŏCiret.y >= 0j
			}else if(cornerY[ret.y+1]<=posY){
				do{
					ret.y++;
				}while(cornerY[ret.y+1]<=posY);	//EɂĂ΂͂܂܂ŏCiret.y < verticalNumj
			}
		}
		//
		return ret;
	}
	//---------------
	//ubNACe̔
	//---------------
	public void operateBlockNumFormItem(int typePair,int num){
		//
		if(typePair==FDBItem.I_PAIR_UP){
			//鐔ȏɂ͑₹Ȃ
			if(num>restBreakableBlockStart-restBreakableBlockNow){
				num=restBreakableBlockStart-restBreakableBlockNow;
			}
			//ŃubNʒuw肷
			int rndX=(int)(Math.random()*horizontalNum);
			int rndY=(int)(Math.random()*verticalNum);
			while(num>0){
				//ẅʒuubNゾȂŏ̏Ԃɖ߂
				if( blockResistStart[rndX][rndY]!=0 && blockResistNow[rndX][rndY]==0 ){
					blockResistNow[rndX][rndY]=blockResistStart[rndX][rndY];
					restBreakableBlockNow++;
					num--;	//1ÃubNʒu𗐐Ŏw
					rndX=(int)(Math.random()*horizontalNum);
					rndY=(int)(Math.random()*verticalNum);
				}else{	//ႦΎ̈ʒuɐi߂Ă
					rndX++;
					if(rndX>=horizontalNum){
						rndX=0;
						rndY++;
						if(rndY>=verticalNum){
							rndX=0;
							rndY=0;
						}
					}
				}
			}
		}else/* if(typePair==Item.I_PAIR_DOWN)*/{
			//[ȉɂ͌点Ȃ
			if(restBreakableBlockNow-num<=clearBlockNum){
				num=restBreakableBlockNow-(clearBlockNum+1);
			}
			//ŃubNʒuw肷
			int rndX=(int)(Math.random()*horizontalNum);
			int rndY=(int)(Math.random()*verticalNum);
			while(num>0){
				//ẅʒuubNԂȂ
				if( blockResistNow[rndX][rndY]>0 && blockResistStart[rndX][rndY]<4 ){
					blockResistNow[rndX][rndY]=0;
					restBreakableBlockNow--;
					num--;	//1ÃubNʒu𗐐Ŏw
					rndX=(int)(Math.random()*horizontalNum);
					rndY=(int)(Math.random()*verticalNum);
				}else{	//ႦΎ̈ʒuɐi߂Ă
					rndX++;
					if(rndX>=horizontalNum){
						rndX=0;
						rndY++;
						if(rndY>=verticalNum){
							rndX=0;
							rndY=0;
						}
					}
				}
			}
		}
	}
}
