import java.applet.AudioClip;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JScrollPane;
import javax.swing.KeyStroke;


public class FDBFrame extends JFrame implements ActionListener, WindowListener, FDBPanelListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//----------------------------------------------------------------------------
	public static void main(String[] args) {
		FDBFrame frame=new FDBFrame();
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);	//E~ł͉Ȃiŏj
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//----------------------------------------------------------------
	//Applicationł̓Xe[W𐧌
	public static final int STAGE_MAX=30;
	//^Cgɕt镶
	private static final String TITLE_STRING=" - FullDirectionBlock";
	//{ݒ
	//---N[h
	public static final int RUN_EDIT=0;
	public static final int RUN_PLAY=1;
	//---ʉ
	public static final int SND_IN=0;
	public static final int SND_OFF=1;
	public static final int SND_OUT_AU=2;
	public static final int SND_OUT_WAV=3;
	//---Xe[WI
	public static final int STG_SELECTABLE=0;
	public static final int STG_UNSELECTABLE=1;
	//----------------------------------------------------------------
	//
	FDBFileIO fileIO;
	FDBCipher cipher;
	FDBPanel field;
	//
	FDBNumSizeDialog numSizeDialog;
	FDBSetDialog setDialog;
	FDBBlockDialog blockDialog;
	FDBSoundDialog soundDialog;
	//
	FDBJarDialog jarDialog;
	FDBAppletDialog appletDialog;
	//{ݒ
	int runType;
	int sndType;
	int stgType;
	//----------------------------------------------------------------
	//
	JMenuBar mainMenu=new JMenuBar();
	//
	JMenu menuFile=new JMenu("t@C(F)");
	JMenuItem menuItemNew=new JMenuItem("VK(N)...");
	JMenuItem menuItemOpen=new JMenuItem("J(O)");
	JMenuItem menuItemSave=new JMenuItem("㏑ۑ(S)");
	JMenuItem menuItemSaveAs=new JMenuItem("Otĕۑ(R)...");
	JMenuItem menuItemSetNumSize=new JMenuItem("Xe[WETCY(1)...");
	JMenuItem menuItemSetStage=new JMenuItem("Xe[We(2)...");
	JMenuItem menuItemSetBlock=new JMenuItem("ubNzu(3)...");
	JMenuItem menuItemSetSound=new JMenuItem("ʉ(4)...");
	JMenuItem menuItemExit=new JMenuItem("I(X)");
	//
	JMenuItem menuItemSaveReachStage=new JMenuItem("BXe[Wۑ(S)");
	JMenuItem menuItemFormatReachStage=new JMenuItem("BXe[W(F)");
	//
	JMenu menuStage=new JMenu("Xe[W(S)");
	JRadioButtonMenuItem menuItemStage[]=new JRadioButtonMenuItem[STAGE_MAX];
	//
	JMenu menuOtherSet=new JMenu("ݒ(E)");
	JMenuItem menuItemFitSize=new JMenuItem("t[TCY(F)");
	JMenuItem menuItemRestart=new JMenuItem("ēǂݍ(R)");
	JMenu menuDebug=new JMenu("fobO[h(D)");
	JRadioButtonMenuItem menuItemDebugOn=new JRadioButtonMenuItem("on(N)");
	JRadioButtonMenuItem menuItemDebugOff=new JRadioButtonMenuItem("off(F)");
	JMenuItem menuItemDebugStageClear=new JMenuItem("Xe[WNA(C)");
	JMenuItem menuItemDebugLastStage=new JMenuItem("ŏIXe[W(S)");
	//
	JMenu menuOut=new JMenu("o(O)");
	JMenuItem menuItemOutDist=new JMenuItem("vCpt@C(P)...");
	JMenuItem menuItemOutWeb=new JMenuItem("vy[W(W)...");
	//
	JMenu menuHelp=new JMenu("wv(H)");
	JMenuItem menuItemAuther=new JMenuItem("pY쐬(M)");
	JMenuItem menuItemAbout=new JMenuItem("FullDirectionBlockɂ(A)");
	//
	//****************************************************************************
	//
	//----------------------------------------------------------------------------
	public FDBFrame() {
		//܂t@Co̓NX
		fileIO=new FDBFileIO(this);
		//{ݒǂݍ
		int[] setInfo=fileIO.getSetInfo(false);
		runType=setInfo[FDBFileIO.SET_DATA_RUN];
		sndType=setInfo[FDBFileIO.SET_DATA_SOUND];
		stgType=setInfo[FDBFileIO.SET_DATA_STAGE];
		//o̓NX̎ɈÍNXiÍݒǂݍ݁Ao̓NX̐ݒǉj
		cipher=new FDBCipher(this,fileIO);
		//
		//ҏW[hȂƃtH_ɏf[^
		if(runType==RUN_EDIT){
			fileIO.formatWorkFolder();
		}
		//----------------------------------------------------------------------
		//{ݒɂăj[ڂ
		setMenuItem();
		//j[jbNiL[{[hAlt+?őIj
		menuFile.setMnemonic(KeyEvent.VK_F);
		menuItemNew.setMnemonic(KeyEvent.VK_N);
		menuItemOpen.setMnemonic(KeyEvent.VK_O);
		menuItemSave.setMnemonic(KeyEvent.VK_S);
		menuItemSaveAs.setMnemonic(KeyEvent.VK_R);
		menuItemSetNumSize.setMnemonic(KeyEvent.VK_1);
		menuItemSetStage.setMnemonic(KeyEvent.VK_2);
		menuItemSetBlock.setMnemonic(KeyEvent.VK_3);
		menuItemSetSound.setMnemonic(KeyEvent.VK_4);
		menuItemExit.setMnemonic(KeyEvent.VK_X);
		menuItemSaveReachStage.setMnemonic(KeyEvent.VK_S);
		menuItemFormatReachStage.setMnemonic(KeyEvent.VK_F);
		menuStage.setMnemonic(KeyEvent.VK_S);
		menuOtherSet.setMnemonic(KeyEvent.VK_E);
		menuItemFitSize.setMnemonic(KeyEvent.VK_F);
		menuItemRestart.setMnemonic(KeyEvent.VK_R);
		menuDebug.setMnemonic(KeyEvent.VK_D);
		menuItemDebugOn.setMnemonic(KeyEvent.VK_N);
		menuItemDebugOff.setMnemonic(KeyEvent.VK_F);
		menuItemDebugStageClear.setMnemonic(KeyEvent.VK_C);
		menuItemDebugLastStage.setMnemonic(KeyEvent.VK_S);
		menuOut.setMnemonic(KeyEvent.VK_O);
		menuItemOutDist.setMnemonic(KeyEvent.VK_P);
		menuItemOutWeb.setMnemonic(KeyEvent.VK_W);
		menuHelp.setMnemonic(KeyEvent.VK_H);
		menuItemAuther.setMnemonic(KeyEvent.VK_M);
		menuItemAbout.setMnemonic(KeyEvent.VK_A);
		//ANZ[^[iL[{[h̃V[gJbgj
		menuItemNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,Event.CTRL_MASK));
		menuItemOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,Event.CTRL_MASK));
		menuItemSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,Event.CTRL_MASK));
		menuItemSaveAs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,Event.CTRL_MASK));
		menuItemSetNumSize.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1,0));
		menuItemSetStage.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2,0));
		menuItemSetBlock.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3,0));
		menuItemSetSound.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4,0));
		menuItemExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,Event.CTRL_MASK));
		menuItemFitSize.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5,0));
		menuItemRestart.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F6,0));
		menuItemDebugOn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F7,0));
		menuItemDebugOff.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F8,0));
		menuItemOutDist.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F11,0));
		menuItemOutWeb.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F12,0));
		//ẽCxg
		menuItemNew.addActionListener(this);
		menuItemOpen.addActionListener(this);
		menuItemSave.addActionListener(this);
		menuItemSaveAs.addActionListener(this);
		menuItemSetNumSize.addActionListener(this);
		menuItemSetStage.addActionListener(this);
		menuItemSetBlock.addActionListener(this);
		menuItemSetSound.addActionListener(this);
		menuItemExit.addActionListener(this);
		menuItemSaveReachStage.addActionListener(this);
		menuItemFormatReachStage.addActionListener(this);
		for(int r=0;r<STAGE_MAX;r++){
			menuItemStage[r].addActionListener(this);
		}
		menuItemFitSize.addActionListener(this);
		menuItemRestart.addActionListener(this);
		menuItemDebugOn.addActionListener(this);
		menuItemDebugOff.addActionListener(this);
		menuItemDebugStageClear.addActionListener(this);
		menuItemDebugLastStage.addActionListener(this);
		menuItemOutDist.addActionListener(this);
		menuItemOutWeb.addActionListener(this);
		menuItemAuther.addActionListener(this);
		menuItemAbout.addActionListener(this);
		addWindowListener(this);
		//----------------------------------------------------------------------
		//ŃXN[̘̈g𓾂邽߁AN̓o[\ȂTCYɁiJARo͕͂̂ۏłȂj
		setSize(850,650);
		//Reig
		Container cp=getContentPane();
		//ipỸTCYJAR̂gĂAN͍ƃtH_̂Ȃ̂łj
		field=new FDBPanel(this,new Dimension(setInfo[FDBFileIO.SET_DATA_WIDTH],setInfo[FDBFileIO.SET_DATA_HEIGHT]));
		JScrollPane scPanel=new JScrollPane(field);
		cp.add(scPanel,BorderLayout.CENTER);
		//
		numSizeDialog=new FDBNumSizeDialog(this,fileIO);
		setDialog=new FDBSetDialog(this,fileIO);
		blockDialog=new FDBBlockDialog(this,fileIO);
		soundDialog=new FDBSoundDialog(this,fileIO);
		//
		jarDialog=new FDBJarDialog(this,fileIO);
		appletDialog=new FDBAppletDialog(this,fileIO);
		//
		if(runType==RUN_EDIT){
			setTitleString();	//^Cgݒ̓t@Co̓NX쐬
		}else{
			setTitleString(cipher.getTitle());	//vC[hł͏o͎Ɏw肵^CgirύXȂj
		}
		//
		//t[TCY߂Ɏg߃XN[̈niƕ𓾂Ȃ̂ōŌɓnj
		field.setScrollEdge(scPanel);
		//NɃsb^ɍ킹邱Ƃɂ
		fitFrameSize(true);
	}
	//{ݒɍ킹ăj[\zirύX͂Ȃj
	private void setMenuItem(){
		//---file
		if(runType==RUN_EDIT){
			menuFile.add(menuItemNew);
			menuFile.add(menuItemOpen);
			menuFile.addSeparator();
			menuFile.add(menuItemSave);
			menuFile.add(menuItemSaveAs);
			menuFile.addSeparator();
			menuFile.add(menuItemSetNumSize);
			menuFile.add(menuItemSetStage);
			menuFile.add(menuItemSetBlock);
			menuFile.add(menuItemSetSound);
			menuFile.addSeparator();
			menuItemSaveReachStage.setEnabled(false);
			menuItemFormatReachStage.setEnabled(false);
		}else if(runType==RUN_PLAY){
			menuItemNew.setEnabled(false);
			menuItemOpen.setEnabled(false);
			menuItemSave.setEnabled(false);
			menuItemSaveAs.setEnabled(false);
			menuItemSetNumSize.setEnabled(false);
			menuItemSetStage.setEnabled(false);
			menuItemSetBlock.setEnabled(false);
			menuItemSetSound.setEnabled(false);
			if(stgType==STG_SELECTABLE){
				menuItemSaveReachStage.setEnabled(false);
				menuItemFormatReachStage.setEnabled(false);
			}else{
				menuFile.add(menuItemSaveReachStage);
				menuFile.add(menuItemFormatReachStage);
				menuFile.addSeparator();
			}
		}
		menuFile.add(menuItemExit);
		//---stage
		//WI{^ݒ
		ButtonGroup bgStage=new ButtonGroup();
		for(int r=0;r<STAGE_MAX;r++){
			menuItemStage[r]=new JRadioButtonMenuItem("Xe[W"+(r+1));
			menuStage.add(menuItemStage[r]);
			bgStage.add(menuItemStage[r]);
		}
		menuItemStage[0].setSelected(true);
		//---set
		menuOtherSet.add(menuItemFitSize);
		if(runType==RUN_EDIT){
			menuOtherSet.add(menuItemRestart);
			//WI{^ݒ
			ButtonGroup bgDebug=new ButtonGroup();
			bgDebug.add(menuItemDebugOn);
			bgDebug.add(menuItemDebugOff);
			menuItemDebugOff.setSelected(true);
			enableDebugMenu(false);
			//
			menuDebug.add(menuItemDebugOn);
			menuDebug.add(menuItemDebugOff);
			menuDebug.addSeparator();
			menuDebug.add(menuItemDebugStageClear);
			menuDebug.add(menuItemDebugLastStage);
			//
			menuOtherSet.add(menuDebug);
		}else if(runType==RUN_PLAY){
			menuItemRestart.setEnabled(false);
			//
			menuItemDebugOn.setEnabled(false);
			menuItemDebugOff.setEnabled(false);
			menuItemDebugStageClear.setEnabled(false);
			menuItemDebugLastStage.setEnabled(false);
		}
		//---out
		if(runType==RUN_EDIT){
			menuOut.add(menuItemOutDist);
			menuOut.add(menuItemOutWeb);
		}else if(runType==RUN_PLAY){
			menuItemOutDist.setEnabled(false);
			menuItemOutWeb.setEnabled(false);
		}
		//---help
		if(runType==RUN_EDIT){
			menuItemAuther.setEnabled(false);
		}else if(runType==RUN_PLAY){
			menuHelp.add(menuItemAuther);
		}
		menuHelp.add(menuItemAbout);
		//---
		mainMenu.add(menuFile);
		mainMenu.add(menuStage);
		mainMenu.add(menuOtherSet);
		if(runType==RUN_EDIT){
			mainMenu.add(menuOut);
		}
		mainMenu.add(menuHelp);
		setJMenuBar(mainMenu);
	}
	//****************************************************************************
	//pYݒύX
	//----------------------------------------------------------------------------
	//ʉύX̊{ݒt@C
	public void changeBaseSetting(int snd){
		fileIO.makeSetFile(runType, field.getPreferredSize(), snd, stgType);
	}
	//TCYύX̊{ݒt@C
	public void changeBaseSetting(Dimension size,boolean newPuzzle){
		if(newPuzzle){	//VK쐬iʉj
			fileIO.makeSetFile(runType, size, FDBFrame.SND_IN, stgType);
		}else{			//ݒύXiʉ͂̂܂܁j
			fileIO.makeSetFile(runType, size, sndType, stgType);
		}
	}
	//Xe[WύX̃Xe[WftHgݒt@C
	public void changeDefaultSetting(int stg,boolean newPuzzle){
		if(newPuzzle){	//VK쐬
			fileIO.makeFirstStageFile(stg);	//p̃Xe[Wݒ肵ftHgXe[Wݒt@C쐬
		}else{			//ݒύX
			//݂̃ftHgݒ𓾂āAXe[WύX
			FDBSetFile defSet=field.getDefaultSetting();
			defSet.gStageMax=stg;
			//t@CɏóiftHg0nj
			fileIO.makeStageFile(0, defSet.getDefaultDataString());
			//Xe[W̃t@C폜
			fileIO.deleteUselessStageBlockFiles(stg);
		}
	}
	//ݒύXɃpYăX^[g
	public void restartPuzzle(boolean outFlag){
		//{ݒǂݍ
		int[] setInfo=fileIO.getSetInfo(outFlag);	//o͂JARœBXe[W폜ꍇ̂false
		runType=setInfo[FDBFileIO.SET_DATA_RUN];
		sndType=setInfo[FDBFileIO.SET_DATA_SOUND];
		stgType=setInfo[FDBFileIO.SET_DATA_STAGE];
		//
		field.makePuzzle(new Dimension(setInfo[FDBFileIO.SET_DATA_WIDTH],setInfo[FDBFileIO.SET_DATA_HEIGHT]));
		//t[TCYȂΑ傫
		fitFrameSize(false);
	}
	//****************************************************************************
	//j[Cxg
	//----------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==menuItemNew){
			if(checkChangedData()){		//pYf[^ύXȂ`FbN
				field.pauseIfRuning();
				numSizeDialog.formatData();
				numSizeDialog.setVisible(true);
			}
		}else if(object==menuItemOpen){
			if(checkChangedData()){		//pYf[^ύXȂ`FbN
				field.pauseIfRuning();
				fileIO.load();
			}
		}else if(object==menuItemSave){
			field.pauseIfRuning();
			fileIO.save();
		}else if(object==menuItemSaveAs){
			field.pauseIfRuning();
			fileIO.saveAs();
		}else if(object==menuItemSetNumSize){
			field.pauseIfRuning();
			numSizeDialog.setLatestData(field.getStageMax(), field.getPreferredSize());
			numSizeDialog.setVisible(true);
		}else if(object==menuItemSetStage){
			field.pauseIfRuning();
			setDialog.setLatestData(field.getDefaultSetting(), field.getStageMax());
			setDialog.setVisible(true);
		}else if(object==menuItemSetBlock){
			field.pauseIfRuning();
			blockDialog.setLatestData(field.getStageMax());
			blockDialog.setVisible(true);
		}else if(object==menuItemSetSound){
			field.pauseIfRuning();
			soundDialog.setLatestData(sndType);
			soundDialog.setVisible(true);
		}else if(object==menuItemExit){
			if(checkChangedData()){		//OɃpYf[^ύXȂ`FbN
				//I
				exitAll();
			}
		}else if(object==menuItemSaveReachStage){
			field.pauseIfRuning();
			field.goNextStageToSave();	//NAʂŎɐi܂ۑĂ܂̂h
			//Ot@Cɕۑ邾ipY͂̂܂܁j
			if(cipher.saveStageNum(field.getReachedStage())){
				showFinishDialog("ۑ܂");
			}
		}else if(object==menuItemFormatReachStage){
			field.pauseIfRuning();
			//Ot@C폜ăpYăX^[g
			cipher.deleteStageNum();
			showFinishDialog("܂");
			restartPuzzle(false);	//JAR̃f[^
		}else if(object==menuItemFitSize){
			fitFrameSize(true);	//
		}else if(object==menuItemRestart){
			restartPuzzle(true);
		}else if(object==menuItemDebugOn){
			field.setDebug(true);
			enableDebugMenu(true);
		}else if(object==menuItemDebugOff){
			field.setDebug(false);
			enableDebugMenu(false);
		}else if(object==menuItemDebugStageClear){
			field.debugStageClear();
		}else if(object==menuItemDebugLastStage){
			field.debugLastStage();
		}else if(object==menuItemOutDist){
			field.pauseIfRuning();
			jarDialog.setLatestData(field.getStageMax());
			jarDialog.setVisible(true);
		}else if(object==menuItemOutWeb){
			field.pauseIfRuning();
			appletDialog.setLatestData(field.getStageMax());
			appletDialog.setVisible(true);
		}else if(object==menuItemAuther){
			//field.pauseIfRuning();
			JOptionPane.showMessageDialog(this,	cipher.getAuther(),"pY쐬",JOptionPane.INFORMATION_MESSAGE);
		}else if(object==menuItemAbout){
			//field.pauseIfRuning();
			JOptionPane.showMessageDialog(this,
					"FullDirectionBlock version 1.1"+FDBFileIO.BR+FDBFileIO.BR+"TakanaFactory"+FDBFileIO.BR+"http://www.takana.info/",
					"FullDirectionBlockɂ",JOptionPane.INFORMATION_MESSAGE);
		}else{
			for(int r=0;r<STAGE_MAX;r++){
				if(object==menuItemStage[r]){
					field.selectStageAll(r+1);	//appletp̂𗬗p
					break;
				}
			}
		}
		//L[Cxg󂯎邽߂ɃtH[JXĂ
		field.requestFocus();
	}
	//****************************************************************************
	//windowCxg
	//----------------------------------------------------------------------------
	public void windowActivated(WindowEvent arg0) {
	}
	public void windowClosed(WindowEvent arg0) {
	}
	public void windowClosing(WindowEvent arg0) {
		if(checkChangedData()){		//OɃpYf[^ύXȂ`FbN
			//I
			exitAll();
		}
	}
	public void windowDeactivated(WindowEvent arg0) {
	}
	public void windowDeiconified(WindowEvent arg0) {
	}
	public void windowIconified(WindowEvent arg0) {
	}
	public void windowOpened(WindowEvent arg0) {
	}
	//pYf[^ύXΒӂ𑣂AZ[uipȂtrueԂj
	private boolean checkChangedData(){
		if(fileIO.needSave()){
			int ret=JOptionPane.showConfirmDialog(this,"eύXĂ܂"+FDBFileIO.BR+"ۑ܂H",
					"mF",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE);
			if(ret==JOptionPane.YES_OPTION){
				fileIO.save();	//Z[uōƌpցiŃZ[u~ꍇ̂܂ܐiނHj
			}else if(ret==JOptionPane.CANCEL_OPTION){
				return false;
			}
		}
		//
		return true;
	}
	//I
	private void exitAll(){
		//ƃtH_폜
		if(runType==RUN_EDIT){
			fileIO.deleteWorkFolder();
		}
		//
		fileIO.closeSelfJarFile();
		//
		System.exit(0);
	}
	//*************************************************************
	//
	//-------------------------------------------------------------
	//t[TCYpYɍ킹ĒiNƃj[ut[TCY߁v̂݃sb^tOtruej
	public void fitFrameSize(boolean shortenFlag){
		Dimension differ=field.getSizeDifference();	//TCYߏ蕪擾
		if(!shortenFlag){	//sb^ɒȂȂ傫̂͂̂܂
			if(differ.width>0){		differ.width=0;		}
			if(differ.height>0){	differ.height=0;	}
		}
		setSize(getWidth()-differ.width,getHeight()-differ.height);
		setVisible(true);	//1sƃt[̃tB[hȂǂTCYȂiȂHj
	}
	//t[^Cgݒ
	public void setTitleString(){
		setTitleString(fileIO.getFileName());
	}
	private void setTitleString(String title){
		setTitle(title+TITLE_STRING);
	}
	//
	private void enableDebugMenu(boolean f){
		menuItemDebugStageClear.setEnabled(f);
		menuItemDebugLastStage.setEnabled(f);
	}
	//_CAOŒʒm
	public void showErrorDialog(String message){
		JOptionPane.showMessageDialog(this,message,"G[",JOptionPane.ERROR_MESSAGE);
	}
	public void showFinishDialog(String message){
		JOptionPane.showMessageDialog(this,message,"",JOptionPane.INFORMATION_MESSAGE);
	}
	//*************************************************************
	//Interfacẽ\bh
	//-------------------------------------------------------------
	//j[̃Xe[WI
	public void setStageMenu(int num){							//***Xe[W***
		for(int s=0;s<num;s++){
			menuItemStage[s].setVisible(true);
		}
		for(int s=num;s<STAGE_MAX;s++){
			menuItemStage[s].setVisible(false);
		}
		menuItemStage[0].setSelected(true);		//
	}
	public void setSelectableStage(int num) {					//***I\ȃXe[W***
		if(stgType==STG_SELECTABLE || runType==RUN_EDIT){
			return;	
		}
		//vC[hŎRIs̏ꍇ̂ݏ
		for(int s=0;s<num;s++){
			menuItemStage[s].setEnabled(true);
		}
		for(int s=num;s<STAGE_MAX;s++){
			menuItemStage[s].setEnabled(false);
		}
	}
	public void stageChanged(int num){							//***݂̑IXe[W***
		menuItemStage[num-1].setSelected(true);	//Xe[Wԍzɒ
	}
	//p[^[擾i{ݒȂǂɍ킹ċ[IɁj
	public String getParam(String param, String def) {
		if(param.equals("sound")){
			if(sndType==SND_OFF){
				return "off";
			}else{
				return "se";
			}
		}else if(param.equals("soundtype")){
			if(sndType==SND_OUT_WAV){
				return "wav";
			}else{
				return "au";
			}
		}else if(param.equals("debug")){
			if(menuItemDebugOn.isSelected()){
				return "on";
			}else{
				return "off";
			}
		}else{
			return def;
		}
	}
	//eLXgt@Cǂݍ
	public String[] readTextFile(String fileOrder) {
		String ret[];
		if(runType==RUN_EDIT){
			ret=fileIO.getFileString(fileOrder);		//ҏW[hȂSčƃtH_
		}else/* if(runType==RUN_PLAY)*/{
			ret=fileIO.getFileStringInJar(fileOrder);	//vC[hȂSJAR
		}
		//
		if(ret!=null){
			return ret;
		}else{
			return new String[0];
		}
	}
	//摜擾
	public Image getImage(String target) {
		if(runType==RUN_EDIT){
			if(target.indexOf("image")==0){
				return fileIO.getImageFile(target, false);		//VXegp摜JARimagetH_
			}else{
				return fileIO.getImageFile(target, true);		//wi摜͍ƃtH_
			}
		}else/* if(runType==RUN_PLAY)*/{
			return fileIO.getImageFile(target, false);			//vC[hȂSJAR
		}
	}
	//ʉ擾
	public AudioClip getSound(String target) {
		if(runType==RUN_EDIT){
			if(sndType==SND_IN){
				return fileIO.getSoundFile(target, false);	//̂gȂJAR
			}else{	//SND_OUT_AU,SND_OUT_WAV(SND_OFFł͌Ă΂Ȃ)
				return fileIO.getSoundFile(target, true);	//Ot@C荞݂Ă΍ƃtH_
			}
		}else/* if(runType==RUN_PLAY)*/{
			return fileIO.getSoundFile(target, false);		//vC[hȂSJAR
		}
	}
	//OۑĂ铞BXe[WipY쐬ɂ̂General`FbNj
	public int loadReacdedStage(){
		if(stgType==STG_SELECTABLE || runType==RUN_EDIT){
			return 1;	
		}else{		//vC[hŃXe[WI𐧌Ăꍇ݂̂Ώ
			return cipher.loadStageNum();
		}
		
	}
	//܂y[W֔ԁiApplicationł͎gȂj
	public URL changeToURL(String path) {
		try{									//y[W̃pXwURL
			return (new File(System.getProperty("user.dir")+FDBFileIO.SEP+path)).toURI().toURL();
		}catch(MalformedURLException e){
			return null;
		}
	}
	public void showPremiumPage(URL jumpURL) {
		//no work
	}
}
