import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.jar.Attributes;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;
import java.util.jar.Manifest;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
//import javax.swing.filechooser.FileNameExtensionFilter;


public class FDBJarDialog extends JDialog implements ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	//Ăяo
	FDBFrame frame;
	FDBFileIO fileIO;
	//
	File pathJar=null;
	//---------------------------------------------
	JTextField fieldPath=new JTextField("",20);
	JButton buttonPath=new JButton("w");
	JTextField fieldTitle=new JTextField(15);
	//
	DefaultComboBoxModel comboModelStart=new DefaultComboBoxModel();
	//
	JRadioButton radioContOn=new JRadioButton("On",true);
	JRadioButton radioContOff=new JRadioButton("Off");
	//
	JRadioButton radioSelectOn=new JRadioButton("ŏSXe[W\",true);
	JRadioButton radioSelectOff=new JRadioButton("NAς݃Xe[Ŵ");
	//
	JTextField fieldName=new JTextField(12);
	JTextField fieldInfo01=new JTextField(12);
	JTextField fieldInfo02=new JTextField(12);
	//
	JButton buttonOk=new JButton("o");
	JButton buttonCancel=new JButton("");
	//*************************************************************
	//
	//-------------------------------------------------------------
	public FDBJarDialog(FDBFrame frm,FDBFileIO fIO){
		super(frm,"vCpt@Co",true);
		//
		frame=frm;
		fileIO=fIO;
		//
		fieldPath.setEditable(false);	//ڂ͕ҏWłȂ
		ButtonGroup radioGroup1=new ButtonGroup();
		radioGroup1.add(radioContOn);
		radioGroup1.add(radioContOff);
		ButtonGroup radioGroup2=new ButtonGroup();
		radioGroup2.add(radioSelectOn);
		radioGroup2.add(radioSelectOff);
		//
		JPanel jarOutPanel=new JPanel();	//1-1
		jarOutPanel.setLayout(new BorderLayout());
		jarOutPanel.add(new JLabel("o͐F"),BorderLayout.CENTER);
		jarOutPanel.add(buttonPath,BorderLayout.EAST);
		jarOutPanel.add(fieldPath,BorderLayout.SOUTH);
		//
		JPanel jarTitlePanel=new JPanel();		//1-2
		jarTitlePanel.add(new JLabel("^CgF"));
		jarTitlePanel.add(fieldTitle);
		//
		JPanel jarPanel=new JPanel();		//1
		jarPanel.setLayout(new BorderLayout());
		jarPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"vCpt@C"));	//g
		jarPanel.add(jarOutPanel,BorderLayout.CENTER);	//1-1
		jarPanel.add(jarTitlePanel,BorderLayout.SOUTH);	//1-2
		//
		JPanel startPanel=new JPanel();		//2-1
		startPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"JnXe[W"));	//g
		startPanel.add(new JComboBox(comboModelStart));
		//
		JPanel contPanel=new JPanel();		//2-2
		contPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"ReBj["));	//g
		contPanel.add(radioContOn);
		contPanel.add(radioContOff);
		//
		JPanel selectPanel=new JPanel();		//2-3
		selectPanel.setLayout(new GridLayout(2,1));
		selectPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"Xe[WI"));	//g
		selectPanel.add(radioSelectOn);
		selectPanel.add(radioSelectOff);
		//
		JPanel autherNamePanel=new JPanel();		//2-4-1
		autherNamePanel.add(new JLabel("OF"));
		autherNamePanel.add(fieldName);
		//
		JPanel autherInfo01Panel=new JPanel();		//2-4-2
		autherInfo01Panel.add(new JLabel("PF"));
		autherInfo01Panel.add(fieldInfo01);
		//
		JPanel autherInfo02Panel=new JPanel();		//2-4-3
		autherInfo02Panel.add(new JLabel("QF"));
		autherInfo02Panel.add(fieldInfo02);
		//
		JPanel autherPanel=new JPanel();		//2-4
		autherPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"ҏ"));	//g
		autherPanel.setLayout(new GridLayout(3,1));
		autherPanel.add(autherNamePanel);
		autherPanel.add(autherInfo01Panel);
		autherPanel.add(autherInfo02Panel);
		//
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.fill=GridBagConstraints.BOTH;
		GridBagLayout gbl=new GridBagLayout();
		JPanel centerPanel=new JPanel();		//2
		centerPanel.setLayout(gbl);
		gbc.gridwidth=1;
		gbc.gridheight=1;
		gbl.setConstraints(startPanel,gbc);
		centerPanel.add(startPanel);		//2-1
		gbc.gridwidth=GridBagConstraints.REMAINDER;;
		gbc.gridheight=1;
		gbl.setConstraints(contPanel,gbc);
		centerPanel.add(contPanel);		//2-2
		gbc.gridwidth=1;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbl.setConstraints(selectPanel,gbc);
		centerPanel.add(selectPanel);		//2-3
		gbc.gridwidth=GridBagConstraints.REMAINDER;
		gbc.gridheight=GridBagConstraints.REMAINDER;
		gbl.setConstraints(autherPanel,gbc);
		centerPanel.add(autherPanel);		//2-4
		//
		JPanel buttonPanel=new JPanel();		//3
		buttonPanel.add(buttonOk);
		buttonPanel.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(jarPanel,BorderLayout.NORTH);
		cp.add(centerPanel,BorderLayout.CENTER);
		cp.add(buttonPanel,BorderLayout.SOUTH);
		//ẽCxg
		buttonPath.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//*************************************************************
	//_CAO\Ȍ
	//-------------------------------------------------------------
	public void setLatestData(int stg){
		//쐬
		comboModelStart.removeAllElements();
		for(int s=1;s<=stg;s++){
			comboModelStart.addElement(String.valueOf(s));
		}
	}
	//*************************************************************
	//Cxg
	//-------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonPath){
			File file=fileIO.chooseFileOnSave("vCpt@C(*.jar)ɏo","o",pathJar,/*new FileNameExtensionFilter("vCpt@C(*.jar)","jar")*/"jar");
			if(file!=null){
				pathJar=file;
				fieldPath.setText(pathJar.getPath());
				if(fieldTitle.getText().equals("")){
					fieldTitle.setText(pathJar.getName());
				}
			}
		}else if(object==buttonOk){
			if(pathJar==null){
				frame.showErrorDialog("o͐̃vCpt@Cw肵Ă");
				return;
			}
			//o
			if(outputJarFile()){
				//G[IȂ
				frame.showFinishDialog("o͂܂");
				setVisible(false);
			}
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//*************************************************************
	//ftHg̃Xe[WݒɁAo͗pɍڂ
	//-------------------------------------------------------------
	private String getDefaultSetString(){
		//ftHg̃Xe[Wݒ𓾂
		FDBSetFile s0=new FDBSetFile(frame);
		s0.setDefaultData(fileIO.getFileString(FDBFileIO.getTargetStageFileName(0)));
		//JnXe[Wǉ
		int start=Integer.parseInt((String)(comboModelStart.getSelectedItem()));
		if(start!=1){
			s0.gStageStart=start;
		}
		//ReBj[ǉ
		if(radioContOff.isSelected()){
			s0.gStageContinue=false;
		}
		//
		return s0.getDefaultDataString();
	}
	//*************************************************************
	//vCpt@CiJarjւ̏o
	//-------------------------------------------------------------
	private boolean outputJarFile(){
		//
		JarFile selfJarFile=fileIO.getSelfJarFile();
		int[] setInfo=fileIO.getSetInfo(true);
		int stageMax=comboModelStart.getSize();
		//
		try{
			//}jtFXg쐬
			Manifest manifest=new Manifest();
			Attributes attributes=manifest.getMainAttributes();
			attributes.put(Attributes.Name.MANIFEST_VERSION, "1.0");
			attributes.put(Attributes.Name.MAIN_CLASS, "FDBFrame");	//main\bĥNX
			//̃}jtFXgJAR
			JarOutputStream jos=new JarOutputStream(new BufferedOutputStream(new FileOutputStream(pathJar)),manifest);
			//
			//{ݒt@C
			Dimension size=new Dimension(setInfo[FDBFileIO.SET_DATA_WIDTH],setInfo[FDBFileIO.SET_DATA_HEIGHT]);
			int stg=(radioSelectOn.isSelected())?FDBFrame.STG_SELECTABLE:FDBFrame.STG_UNSELECTABLE;
			String setData=FDBFileIO.getSetFileString(FDBFrame.RUN_PLAY, size, setInfo[FDBFileIO.SET_DATA_SOUND], stg);
			outputToJarFromString(jos,FDBFileIO.SET_FILE,setData);
			//Íݒt@C
			String cipherData=FDBCipher.getCipherFileString(pathJar.getName(),fieldTitle.getText(),
																			fieldName.getText(),fieldInfo01.getText(),fieldInfo02.getText());
			outputToJarFromString(jos, FDBCipher.CIPHER_FILE, cipherData);
			//NXAVXe摜
			Enumeration<JarEntry> entries=selfJarFile.entries();
			while(entries.hasMoreElements()){
				JarEntry entry=(JarEntry)entries.nextElement();
				if(FDBFileIO.checkEntryExtention(entry, ".gif",".class")){	//ClassGIF摜iVXegp摜jSĈڂ
					outputToJarFromJar(jos,selfJarFile,entry.getName());
				}
			}
			//Xe[WݒAubNzu
			//	iXe[Wݒ̓ftHgɂ͒ǉvfAʈj
			String sTarget=FDBFileIO.getTargetStageFileName(0);
			File sBeforeFile=null;
			outputToJarFromString(jos,sTarget,getDefaultSetString());	//t@Cł͂Ȃ񂩂JAR
			//	iubNzu̓ftHgłj
			String bTarget=FDBFileIO.getTargetBlockFileName(0);
			File bBeforeFile=fileIO.getWorkFile(FDBFileIO.getTargetBlockFileName(0));
			outputToJarFromFile(jos,bBeforeFile,bTarget);
			//	iftHgȊO͂܂Ƃ߂ă[vj
			for(int s=1;s<=stageMax;s++){
				//
				sTarget=FDBFileIO.getTargetStageFileName(s);
				sBeforeFile=fileIO.getWorkFile(sTarget);
				outputToJarFromFile(jos,sBeforeFile,sTarget);
				//
				bTarget=FDBFileIO.getTargetBlockFileName(s);
				bBeforeFile=fileIO.getWorkFile(FDBFileIO.getTargetBlockFileName(s));
				outputToJarFromFile(jos,bBeforeFile,bTarget);
			}
			//ʉ
			switch(setInfo[FDBFileIO.SET_DATA_SOUND]){
			case FDBFrame.SND_IN:
				//t@CXɎw
				for(int s=0;s<FDBSound.SE_ALL;s++){
					outputToJarFromJar(jos,selfJarFile,FDBFileIO.SE_FOLDER+'/'+FDBSound.SOUND_NAME[s]+".au");	//JARseparator'/'
				}
				break;
			case FDBFrame.SND_OFF:
				break;
			case FDBFrame.SND_OUT_WAV:
			case FDBFrame.SND_OUT_AU:
				outputToJarFromWorkFolder(jos,FDBFileIO.SE_FOLDER);		//tH_St@C
			}
			//wi摜
			outputToJarFromWorkFolder(jos,FDBFileIO.BACK_FOLDER);		//tH_St@C
			//
			jos.close();
			//
			return true;
		}catch(IOException ioe){
			frame.showErrorDialog("o͂Ɏs܂"+FDBFileIO.BR+ioe.toString());
			return false;
		}catch(NullPointerException npe){	//selfJarɖړĨt@CȂ
			frame.showErrorDialog("o͂Ɏs܂"+FDBFileIO.BR+npe.toString());
			return false;
		}
	}
	//ƃtH_̎wtH_St@C
	private void outputToJarFromWorkFolder(JarOutputStream jos,String folderInWork) throws IOException{
		File beforeFolder=fileIO.getWorkFile(folderInWork);
		if(beforeFolder.exists()){
			String[] targetNames=beforeFolder.list();
			for(int b=0;b<targetNames.length;b++){
				File before=new File(beforeFolder.getPath()+FDBFileIO.SEP+targetNames[b]);
				String target=folderInWork+"/"+targetNames[b];		//JARseparator'/'
				if(before.isFile()){	//tH_͂Ȃ͂ł邪ꉞ
					outputToJarFromFile(jos,before,target);
				}
			}
		}
	}
	//*************************************************************
	//Jarɏ
	//-------------------------------------------------------------
	//𒼐ڂ
	private static void outputToJarFromString(JarOutputStream jos,String target,String data) throws IOException{
		//Gg[ǉ
		JarEntry cipherEntry=new JarEntry(target);	//
		jos.putNextEntry(cipherEntry);
		//
		jos.write(data.getBytes());
		//
		jos.closeEntry();
	}
	//selfJar
	private static void outputToJarFromJar(JarOutputStream jos,JarFile selfJarFile,String target) throws IOException,NullPointerException{
		//
		JarEntry entryFrom=new JarEntry(target);
		//
		BufferedInputStream bis=new BufferedInputStream(selfJarFile.getInputStream(entryFrom));
		//
		outputToJar(jos,bis,target);
	}
	//ƃtH_̃t@C
	private static void outputToJarFromFile(JarOutputStream jos,File file,String target) throws IOException{
		//
		if(!file.exists()){	return;	}
		//
		BufferedInputStream bis=new BufferedInputStream(new FileInputStream(file));
		//
		outputToJar(jos,bis,target);
	}
	//streamɂ̋ʕ
	private static void outputToJar(JarOutputStream jos,BufferedInputStream bis,String target) throws IOException{
		//
		JarEntry entryTo=new JarEntry(target);
		jos.putNextEntry(entryTo);
		//
		int b;
		while((b=bis.read())!=-1){
			jos.write((byte)b);
		}
		//
		jos.closeEntry();
		bis.close();
	}
}
