import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class FDBSetDialog extends JDialog implements ActionListener,ListSelectionListener, WindowListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	private static final String NO_IMAGE=" - ";
	//
	//Ăяo
	FDBFrame frame;
	FDBFileIO fileIO;
	//
	FDBSetFile s0,s1;
	//------------------------------
	//
	DefaultListModel listModelStage=new DefaultListModel();
	JList listStage=new JList(listModelStage);
	//
	SpinnerNumberModel barsLength=new SpinnerNumberModel(100,1,null,10);
	JButton barsColor=new JButton();
	SpinnerNumberModel barsOverhang=new SpinnerNumberModel(15,1,null,1);
	//
	SpinnerNumberModel ballCount=new SpinnerNumberModel(5,-1,null,1);
	SpinnerNumberModel ballSpeed=new SpinnerNumberModel(15,1,null,1);
	SpinnerNumberModel ballRadius=new SpinnerNumberModel(10,1,null,1);
	JButton ballColor=new JButton();
	//
	JCheckBox wallUp=new JCheckBox("");
	JCheckBox wallDown=new JCheckBox("");
	JCheckBox wallLeft=new JCheckBox("");
	JCheckBox wallRight=new JCheckBox("E");
	//
	JButton backColor=new JButton();
	JTextField backImage=new JTextField(NO_IMAGE);
	JButton backImageSelect=new JButton("摜I");
	JButton backImageDelete=new JButton("");
	File backImageFile=null;
	//
	SpinnerNumberModel lifeupScore=new SpinnerNumberModel(500,0,null,100);
	SpinnerNumberModel powerEffect=new SpinnerNumberModel(5,null,null,1);
	SpinnerNumberModel clearRate=new SpinnerNumberModel(100,0,100,1);
	SpinnerNumberModel frontLine=new SpinnerNumberModel(15,1,null,1);
	//
	SpinnerNumberModel itemRate=new SpinnerNumberModel(15,0,100,1);
	SpinnerNumberModel itemBarLong=new SpinnerNumberModel(6,0,null,1);
	SpinnerNumberModel itemBarShort=new SpinnerNumberModel(6,0,null,1);
	SpinnerNumberModel itemBallBig=new SpinnerNumberModel(6,0,null,1);
	SpinnerNumberModel itemBallSmall=new SpinnerNumberModel(6,0,null,1);
	SpinnerNumberModel itemSpeedUp=new SpinnerNumberModel(6,0,null,1);
	SpinnerNumberModel itemSpeedDown=new SpinnerNumberModel(6,0,null,1);
	SpinnerNumberModel itemLifeUp=new SpinnerNumberModel(2,0,null,1);
	SpinnerNumberModel itemLifeDown=new SpinnerNumberModel(2,0,null,1);
	SpinnerNumberModel itemBlockIncrease=new SpinnerNumberModel(2,0,null,1);
	SpinnerNumberModel itemBlockDecrease=new SpinnerNumberModel(2,0,null,1);
	SpinnerNumberModel itemScoreUp=new SpinnerNumberModel(2,0,null,1);
	SpinnerNumberModel itemScoreDown=new SpinnerNumberModel(2,0,null,1);
	SpinnerNumberModel itemBlockHide=new SpinnerNumberModel(2,0,null,1);
	SpinnerNumberModel itemGoThrough=new SpinnerNumberModel(1,0,null,1);
	SpinnerNumberModel itemKeepIn=new SpinnerNumberModel(1,0,null,1);
	SpinnerNumberModel itemBallIncrease=new SpinnerNumberModel(1,0,null,1);
	//
	JButton buttonDelete=new JButton("Xe[W");
	JButton buttonSave=new JButton("Xe[Wۑ");
	JButton buttonEnd=new JButton("I");
	//------------------------------
	//List̒PƑÎ
	int selected;
	//*************************************************************
	//
	//-------------------------------------------------------------
	public FDBSetDialog(FDBFrame frm,FDBFileIO fIO){
		super(frm,"Xe[Wݒ",true);
		//
		frame=frm;
		fileIO=fIO;
		s0=new FDBSetFile(frame);
		s1=new FDBSetFile(frame);
		//Xg쐬i\Oɍ蒼j
		makeStageList(FDBFrame.STAGE_MAX);
		//
		JPanel panelStage=new JPanel();
		JScrollPane scPanel=new JScrollPane(listStage);
		scPanel.setPreferredSize(new Dimension(120,400));
		panelStage.add(scPanel);
		//
		JPanel panelSetBar=new JPanel();
		panelSetBar.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"o["));	//g
		panelSetBar.setLayout(new BorderLayout());
		JPanel panelSetBarA=new JPanel();
		JPanel panelSetBarB=new JPanel();
		panelSetBarA.setLayout(new GridLayout(4,1));
		panelSetBarB.setLayout(new GridLayout(4,1));
		panelSetBarA.add(new JLabel(""));			panelSetBarB.add(new JSpinner(barsLength));
		barsColor.setBackground(Color.BLACK);
		panelSetBarA.add(new JLabel("F"));			panelSetBarB.add(barsColor);
		panelSetBarA.add(new JLabel(""));		panelSetBarB.add(new JSpinner(barsOverhang));
		panelSetBar.add(panelSetBarA,BorderLayout.WEST);
		panelSetBar.add(panelSetBarB,BorderLayout.CENTER);
		//
		JPanel panelSetBall=new JPanel();
		panelSetBall.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"{["));	//g
		panelSetBall.setLayout(new BorderLayout());
		JPanel panelSetBallA=new JPanel();
		JPanel panelSetBallB=new JPanel();
		panelSetBallA.setLayout(new GridLayout(4,1));
		panelSetBallB.setLayout(new GridLayout(4,1));
		panelSetBallA.add(new JLabel(""));		panelSetBallB.add(new JSpinner(ballCount));
		panelSetBallA.add(new JLabel("x"));		panelSetBallB.add(new JSpinner(ballSpeed));
		panelSetBallA.add(new JLabel("a"));		panelSetBallB.add(new JSpinner(ballRadius));
		ballColor.setBackground(Color.BLACK);
		panelSetBallA.add(new JLabel("F"));		panelSetBallB.add(ballColor);
		panelSetBall.add(panelSetBallA,BorderLayout.WEST);
		panelSetBall.add(panelSetBallB,BorderLayout.CENTER);
		//
		JPanel panelSetWall=new JPanel();
		panelSetWall.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),""));	//g
		panelSetWall.setLayout(new GridLayout(4,1));
		panelSetWall.add(wallUp);
		panelSetWall.add(wallDown);
		panelSetWall.add(wallLeft);
		panelSetWall.add(wallRight);
		//
		JPanel panelSetBack=new JPanel();
		panelSetBack.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"wi"));	//g
		panelSetBack.setLayout(new BorderLayout());
		JPanel panelSetBackA=new JPanel();
		JPanel panelSetBackB=new JPanel();
		panelSetBackA.setLayout(new GridLayout(4,1));
		panelSetBackB.setLayout(new GridLayout(4,1));
		backColor.setBackground(Color.WHITE);
		panelSetBackA.add(new JLabel("F"));			panelSetBackB.add(backColor);
		backImage.setEditable(false);
		panelSetBackA.add(new JLabel("摜"));			panelSetBackB.add(backImage);
		panelSetBackA.add(new JLabel(""));				panelSetBackB.add(backImageSelect);
		panelSetBackA.add(new JLabel(""));				panelSetBackB.add(backImageDelete);
		panelSetBack.add(panelSetBackA,BorderLayout.WEST);
		panelSetBack.add(panelSetBackB,BorderLayout.CENTER);
		//
		JPanel panelSetOther=new JPanel();
		panelSetOther.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"̑"));	//g
		panelSetOther.setLayout(new BorderLayout());
		JPanel panelSetOtherA=new JPanel();
		JPanel panelSetOtherB=new JPanel();
		panelSetOtherA.setLayout(new GridLayout(4,1));
		panelSetOtherB.setLayout(new GridLayout(4,1));
		panelSetOtherA.add(new JLabel("{[链_"));			panelSetOtherB.add(new JSpinner(lifeupScore));
		panelSetOtherA.add(new JLabel("͂̋"));		panelSetOtherB.add(new JSpinner(powerEffect));
		panelSetOtherA.add(new JLabel("jŃNA["));			panelSetOtherB.add(new JSpinner(clearRate));
		panelSetOtherA.add(new JLabel("o[ƃubŇ"));		panelSetOtherB.add(new JSpinner(frontLine));
		panelSetOther.add(panelSetOtherA,BorderLayout.CENTER);
		panelSetOther.add(panelSetOtherB,BorderLayout.EAST);
		//
		JPanel panelSetItem=new JPanel();
		panelSetItem.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"ACe"));	//g
		panelSetItem.setLayout(new GridLayout(1,2));
		JPanel panelSetItemA=new JPanel();
		panelSetItemA.setLayout(new BorderLayout());
		JPanel panelSetItemAL=new JPanel();
		JPanel panelSetItemAR=new JPanel();
		panelSetItemAL.setLayout(new GridLayout(10,1));
		panelSetItemAR.setLayout(new GridLayout(10,1));
		panelSetItemAL.add(new JLabel("oij"));	panelSetItemAR.add(new JSpinner(itemRate));
		panelSetItemAL.add(new JLabel("[]"));			panelSetItemAR.add(new JLabel("[䗦]"));
		panelSetItemAL.add(new JLabel("o[g"));			panelSetItemAR.add(new JSpinner(itemBarLong));
		panelSetItemAL.add(new JLabel("o[Zk"));			panelSetItemAR.add(new JSpinner(itemBarShort));
		panelSetItemAL.add(new JLabel("{[g"));		panelSetItemAR.add(new JSpinner(itemBallBig));
		panelSetItemAL.add(new JLabel("{[k"));		panelSetItemAR.add(new JSpinner(itemBallSmall));
		panelSetItemAL.add(new JLabel("x"));			panelSetItemAR.add(new JSpinner(itemSpeedUp));
		panelSetItemAL.add(new JLabel("x"));			panelSetItemAR.add(new JSpinner(itemSpeedDown));
		panelSetItemAL.add(new JLabel("{["));		panelSetItemAR.add(new JSpinner(itemLifeUp));
		panelSetItemAL.add(new JLabel("{["));		panelSetItemAR.add(new JSpinner(itemLifeDown));
		panelSetItemA.add(panelSetItemAL,BorderLayout.CENTER);
		panelSetItemA.add(panelSetItemAR,BorderLayout.EAST);
		JPanel panelSetItemB=new JPanel();
		panelSetItemB.setLayout(new BorderLayout());
		JPanel panelSetItemBL=new JPanel();
		JPanel panelSetItemBR=new JPanel();
		panelSetItemBL.setLayout(new GridLayout(10,1));
		panelSetItemBR.setLayout(new GridLayout(10,1));
		panelSetItemBL.add(new JLabel(""));					panelSetItemBR.add(new JLabel(""));
		panelSetItemBL.add(new JLabel("@[]"));			panelSetItemBR.add(new JLabel("[䗦]"));
		panelSetItemBL.add(new JLabel("@ubN"));	panelSetItemBR.add(new JSpinner(itemBlockIncrease));
		panelSetItemBL.add(new JLabel("@ubN"));	panelSetItemBR.add(new JSpinner(itemBlockDecrease));
		panelSetItemBL.add(new JLabel("@_"));		panelSetItemBR.add(new JSpinner(itemScoreUp));
		panelSetItemBL.add(new JLabel("@_"));		panelSetItemBR.add(new JSpinner(itemScoreDown));
		panelSetItemBL.add(new JLabel("@ubNs"));	panelSetItemBR.add(new JSpinner(itemBlockHide));
		panelSetItemBL.add(new JLabel("@ubNђ"));	panelSetItemBR.add(new JSpinner(itemGoThrough));
		panelSetItemBL.add(new JLabel("@{[ێ"));		panelSetItemBR.add(new JSpinner(itemKeepIn));
		panelSetItemBL.add(new JLabel("@{["));		panelSetItemBR.add(new JSpinner(itemBallIncrease));
		panelSetItemB.add(panelSetItemBL,BorderLayout.CENTER);
		panelSetItemB.add(panelSetItemBR,BorderLayout.EAST);
		panelSetItem.add(panelSetItemA);
		panelSetItem.add(panelSetItemB);
		//
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.fill=GridBagConstraints.BOTH;
		GridBagLayout gbl=new GridBagLayout();
		JPanel panelSet=new JPanel();
		panelSet.setLayout(gbl);
		setPanelPos(gbc,gbl,0,0,1,1,panelSetBar);
		panelSet.add(panelSetBar);
		setPanelPos(gbc,gbl,1,0,1,1,panelSetBall);
		panelSet.add(panelSetBall);
		setPanelPos(gbc,gbl,0,1,1,1,panelSetWall);
		panelSet.add(panelSetWall);
		setPanelPos(gbc,gbl,2,0,1,1,panelSetBack);
		panelSet.add(panelSetBack);
		setPanelPos(gbc,gbl,1,1,2,1,panelSetOther);
		panelSet.add(panelSetOther);
		setPanelPos(gbc,gbl,0,2,GridBagConstraints.REMAINDER,GridBagConstraints.REMAINDER,panelSetItem);
		panelSet.add(panelSetItem);
		//
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonDelete);
		panelBtn.add(buttonSave);
		panelBtn.add(buttonEnd);
		//
		setLayout(new BorderLayout());
		add(panelStage,BorderLayout.WEST);
		add(panelSet,BorderLayout.CENTER);
		add(panelBtn,BorderLayout.SOUTH);
		//ẽCxg
		listStage.addListSelectionListener(this);
		ballColor.addActionListener(this);
		barsColor.addActionListener(this);
		wallUp.addActionListener(this);
		wallDown.addActionListener(this);
		wallLeft.addActionListener(this);
		wallRight.addActionListener(this);
		backColor.addActionListener(this);
		backImageSelect.addActionListener(this);
		backImageDelete.addActionListener(this);
		buttonDelete.addActionListener(this);
		buttonSave.addActionListener(this);
		buttonEnd.addActionListener(this);
		addWindowListener(this);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	private void setPanelPos(GridBagConstraints gbc,GridBagLayout gbl,int x,int y,int w,int h,JPanel panel){
		gbc.gridx=x;
		gbc.gridy=y;
		gbc.gridwidth=w;
		gbc.gridheight=h;
		gbl.setConstraints(panel,gbc);
	}
	//*************************************************************
	//Xg
	//-------------------------------------------------------------
	//S̍쐬i\OɁj
	private void makeStageList(int num){
		//
		listModelStage.clear();
		//
		listModelStage.addElement("default"+fileIO.checkDefaultStageFileInWorkFolder());	//̓t@C̗Lł͂ȂiXe[Wۑj
		for(int n=1;n<=num;n++){
			listModelStage.addElement("stage "+n+fileIO.checkFileInWorkFolder(FDBFileIO.getTargetStageFileName(n)));
		}
		//
		listStage.setSelectedIndex(0);
		selected=0;
	}
	//ڂĐݒif[^폜ۑɁj
	private void changeSelectedListElement(){
		if(selected==0){
			listModelStage.set(0,"default"+fileIO.checkDefaultStageFileInWorkFolder());		//̓t@C̗Lł͂ȂiXe[Wۑj
		}else{
			listModelStage.set(selected,"stage "+selected+fileIO.checkFileInWorkFolder(FDBFileIO.getTargetStageFileName(selected)));
		}
	}
	//*************************************************************
	//_CAO\Ȍ
	//-------------------------------------------------------------
	public void setLatestData(FDBSetFile defSetFile,int stg){
		s0=defSetFile;
		//Xg쐬
		makeStageList(stg);
		//IXe[W̃f[^plɎoiftHgݒ肪IĂj
		reflectSelectedStageToPanel();
	}
	//*************************************************************
	//f[^\pl
	//-------------------------------------------------------------
	//ݒt@CNXpl֎o
	private void transferDataToPanel(FDBSetFile set){
		//
		lifeupScore.setValue(set.lifeupScore);
		powerEffect.setValue(set.powerEffect);
		//
		if(set.ballCount==FDBSetFile.BALL_CONTINUE_IN){
			ballCount.setValue(FDBSetFile.BALL_CONTINUE_OUT);
		}else{
			ballCount.setValue(set.ballCount);
		}
		ballSpeed.setValue(set.ballSpeed);
		ballRadius.setValue(set.ballRadius);
		ballColor.setBackground(set.ballColor);
		//
		barsLength.setValue(set.barsLength);
		barsColor.setBackground(set.barsColor);
		barsOverhang.setValue(set.barsOverhang);
		//
		wallUp.setSelected(set.direction[FDBBars.D_UP]);
		wallDown.setSelected(set.direction[FDBBars.D_DOWN]);
		wallLeft.setSelected(set.direction[FDBBars.D_LEFT]);
		wallRight.setSelected(set.direction[FDBBars.D_RIGHT]);
		//
		clearRate.setValue(set.clearRate);
		frontLine.setValue(set.frontLine);
		//
		backColor.setBackground(set.backColor);
		if(set.backImage==null){
			backImage.setText(NO_IMAGE);
		}else{
			backImage.setText(FDBFileIO.changeImagePathToName(set.backImage));
		}
		backImageFile=null;		//ɂŏ̓pX͂Ȃ
		//
		itemRate.setValue(set.itemRate);
		itemBarLong.setValue(set.itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_UP]);
		itemBarShort.setValue(set.itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_DOWN]);
		itemBallBig.setValue(set.itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_UP]);
		itemBallSmall.setValue(set.itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_DOWN]);
		itemSpeedUp.setValue(set.itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_UP]);
		itemSpeedDown.setValue(set.itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_DOWN]);
		itemBlockHide.setValue(set.itemRatio[FDBItem.I_TIME_MONO_BLOCKVIEW][FDBItem.I_PAIR_MID]);
		itemGoThrough.setValue(set.itemRatio[FDBItem.I_TIME_MONO_THROUGH][FDBItem.I_PAIR_MID]);
		itemKeepIn.setValue(set.itemRatio[FDBItem.I_TIME_MONO_REFLEX][FDBItem.I_PAIR_MID]);
		itemLifeUp.setValue(set.itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_UP]);
		itemLifeDown.setValue(set.itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_DOWN]);
		itemBlockIncrease.setValue(set.itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_UP]);
		itemBlockDecrease.setValue(set.itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_DOWN]);
		itemScoreUp.setValue(set.itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_UP]);
		itemScoreDown.setValue(set.itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_DOWN]);
		itemBallIncrease.setValue(set.itemRatio[FDBItem.I_ONCE_MONO_DIVIDE][FDBItem.I_PAIR_MID]);
	}
	//plݒt@CNX֊i[
	private void transferDataToSetfile(FDBSetFile set){
		//
		set.lifeupScore=(Integer)lifeupScore.getValue();
		set.powerEffect=(Integer)powerEffect.getValue();
		//
		int bC=(Integer)ballCount.getValue();
		if(bC==FDBSetFile.BALL_CONTINUE_OUT){
			set.ballCount=FDBSetFile.BALL_CONTINUE_IN;
		}else{
			set.ballCount=bC;
		}
		set.ballSpeed=(Integer)ballSpeed.getValue();
		set.ballRadius=(Integer)ballRadius.getValue();
		set.ballColor=ballColor.getBackground();
		//
		set.barsLength=(Integer)barsLength.getValue();
		set.barsColor=barsColor.getBackground();
		set.barsOverhang=(Integer)barsOverhang.getValue();
		//
		set.direction[FDBBars.D_UP]=wallUp.isSelected();
		set.direction[FDBBars.D_DOWN]=wallDown.isSelected();
		set.direction[FDBBars.D_LEFT]=wallLeft.isSelected();
		set.direction[FDBBars.D_RIGHT]=wallRight.isSelected();
		//
		set.clearRate=(Integer)clearRate.getValue();
		set.frontLine=(Integer)frontLine.getValue();
		//
		set.backColor=backColor.getBackground();
		if(backImage.getText().equals(NO_IMAGE)){
			set.backImage=null;															//wi摜Ȃ
		}else{
			if(backImageFile==null){
				set.backImage=FDBFileIO.changeImageNameToPath(backImage.getText());		//ςĂȂi͕svł͂邪j
			}else{
				set.backImage=FDBFileIO.changeImageNameToPath(backImageFile.getName());	//wi摜
			}
		}
		//
		set.itemRate=(Integer)itemRate.getValue();
		set.itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_UP]=(Integer)itemBarLong.getValue();
		set.itemRatio[FDBItem.I_TIME_PAIR_BARLENGTH][FDBItem.I_PAIR_DOWN]=(Integer)itemBarShort.getValue();
		set.itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_UP]=(Integer)itemBallBig.getValue();
		set.itemRatio[FDBItem.I_TIME_PAIR_BALLSIZE][FDBItem.I_PAIR_DOWN]=(Integer)itemBallSmall.getValue();
		set.itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_UP]=(Integer)itemSpeedUp.getValue();
		set.itemRatio[FDBItem.I_TIME_PAIR_SPEED][FDBItem.I_PAIR_DOWN]=(Integer)itemSpeedDown.getValue();
		set.itemRatio[FDBItem.I_TIME_MONO_BLOCKVIEW][FDBItem.I_PAIR_MID]=(Integer)itemBlockHide.getValue();
		set.itemRatio[FDBItem.I_TIME_MONO_THROUGH][FDBItem.I_PAIR_MID]=(Integer)itemGoThrough.getValue();
		set.itemRatio[FDBItem.I_TIME_MONO_REFLEX][FDBItem.I_PAIR_MID]=(Integer)itemKeepIn.getValue();
		set.itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_UP]=(Integer)itemLifeUp.getValue();
		set.itemRatio[FDBItem.I_ONCE_PAIR_LIFE][FDBItem.I_PAIR_DOWN]=(Integer)itemLifeDown.getValue();
		set.itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_UP]=(Integer)itemBlockIncrease.getValue();
		set.itemRatio[FDBItem.I_ONCE_PAIR_BLOCKNUM][FDBItem.I_PAIR_DOWN]=(Integer)itemBlockDecrease.getValue();
		set.itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_UP]=(Integer)itemScoreUp.getValue();
		set.itemRatio[FDBItem.I_ONCE_PAIR_SCORE][FDBItem.I_PAIR_DOWN]=(Integer)itemScoreDown.getValue();
		set.itemRatio[FDBItem.I_ONCE_MONO_DIVIDE][FDBItem.I_PAIR_MID]=(Integer)itemBallIncrease.getValue();
	}
	//IXe[W̃f[^plɎo
	private void reflectSelectedStageToPanel(){
		if(selected==0){
			//ݒt@CNXփeLXgf[^𓖂Ă͂
			s0.setDefaultData(fileIO.getStageData(0));					//
			//pl֎o
			transferDataToPanel(s0);
		}else{
			//ݒt@CNXփeLXgf[^𓖂Ă͂
			s1.setStageData(fileIO.getStageData(selected), false, s0);	//ball͂̃Xe[Ŵ́iReBj[Ȃj
			//pl֎o
			transferDataToPanel(s1);
		}
	}
	//*************************************************************
	//Cxg
	//-------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {		//Button
		Object object=e.getSource();
		if(object==buttonDelete){
			//Xe[Wݒ菉
			if(selected==0){	//ftHg̏ꍇ́AXe[Ŵ݂̏p̒gɂ
				fileIO.makeFirstStageFile(listModelStage.getSize()-1);	//Xe[WvZ
			}else{				//eXe[W̏ꍇ̓t@C폜
				fileIO.deleteStageFile(selected);
			}
			//IXe[W̃f[^plɎoiftHglɂȂj
			reflectSelectedStageToPanel();
			//XgڂĐݒ
			changeSelectedListElement();
			//ݒύXʒm
			fileIO.changePuzzle(false);
		}else if(object==buttonSave){
			//ݒt@Cɕۑ
			if(selected==0){
				transferDataToSetfile(s0);							//pl̃f[^ݒt@CNXɊi[
				fileIO.makeStageFile(0, s0.getDefaultDataString());	//ݒt@CɃeLXgۑ
			}else{
				transferDataToSetfile(s1);									//pl̃f[^ݒt@CNXɊi[
				fileIO.makeStageFile(selected, s1.getStageDataString(s0));	//ݒt@CɃeLXgۑ
			}
			//wi摜΂ŃRs[
			if(backImageFile!=null){
				fileIO.copyBackImage(backImageFile);
			}
			//XgڂĐݒ
			changeSelectedListElement();
			//ݒύXʒm
			fileIO.changePuzzle(false);
		}else if(object==buttonEnd){
			//svɂȂwi摜폜
			fileIO.deleteUselessBackImages(listModelStage.getSize()-1);	//Xe[WvZ
			//ۂɂ͕KpYăX^[giݒ肪ύXĂ邩j
			frame.restartPuzzle(true);
			//
			setVisible(false);
		}else if(object==ballColor){
			ballColor.setBackground(selectColor(ballColor));
		}else if(object==barsColor){
			barsColor.setBackground(selectColor(barsColor));
		}else if(object==backColor){
			backColor.setBackground(selectColor(backColor));
		}else if(object==backImageSelect){
			//ł͔wi摜̃pXێĂ
			File file=fileIO.chooseFileOnLoad("wi摜I","I",backImageFile/*,null*/);
			if(file!=null){
				backImage.setText(file.getName());
				backImageFile=file;
			}
		}else if(object==backImageDelete){
			//wi摜Ȃ
			backImage.setText(NO_IMAGE);
			backImageFile=null;
		}else if(object==wallUp){
			checkWallOpen();
		}else if(object==wallDown){
			checkWallOpen();
		}else if(object==wallLeft){
			checkWallOpen();
		}else if(object==wallRight){
			checkWallOpen();
		}
	}
	public void valueChanged(ListSelectionEvent e) {	//List
		//PƑIłȂ悤ɂ
		int f=listStage.getMinSelectionIndex();
		int l=listStage.getMaxSelectionIndex();
		if(f==selected){
			listStage.setSelectedIndex(l);
			selected=l;
		}else{
			listStage.setSelectedIndex(f);
			selected=f;
		}
		//IXe[W̃f[^plɎo
		reflectSelectedStageToPanel();
	}
	//****************************************************************************
	//windowCxg
	//----------------------------------------------------------------------------
	public void windowActivated(WindowEvent arg0) {
	}
	public void windowClosed(WindowEvent arg0) {
	}
	public void windowClosing(WindowEvent arg0) {
		//svɂȂwi摜폜
		fileIO.deleteUselessBackImages(listModelStage.getSize()-1);	//Xe[WvZ
		//ۂɂ͕KpYăX^[giݒ肪ύXĂ邩j
		frame.restartPuzzle(true);
	}
	public void windowDeactivated(WindowEvent arg0) {
	}
	public void windowDeiconified(WindowEvent arg0) {
	}
	public void windowIconified(WindowEvent arg0) {
	}
	public void windowOpened(WindowEvent arg0) {
	}
	//*************************************************************
	//
	//-------------------------------------------------------------
	private Color selectColor(JButton button){
		Color cc=JColorChooser.showDialog(frame,"wiFI",button.getBackground());
		if(cc!=null){
			return cc;
		}else{
			return button.getBackground();
		}
	}
	//ǂ͂ǂ󂯂˂΂Ȃ
	private void checkWallOpen(){
		if(wallUp.isSelected() && wallDown.isSelected() && wallLeft.isSelected() && wallRight.isSelected()){
			wallDown.setSelected(false);
		}
	}
}
