import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


public class FDBSoundDialog extends JDialog implements ActionListener,ChangeListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	//Ăяo
	FDBFrame frame;
	FDBFileIO fileIO;
	//
	JRadioButton defaultRadio=new JRadioButton("");
	JRadioButton offRadio=new JRadioButton("Ȃ");
	JRadioButton folderRadio=new JRadioButton("O荞");
	JComboBox typeCombo=new JComboBox(new String[]{"au","wav"});
	//
	JButton buttonFolder=new JButton("tH_I");
	JButton buttonOk=new JButton("");
	JButton buttonCancel=new JButton("");
	//*************************************************************
	//
	//-------------------------------------------------------------
	public FDBSoundDialog(FDBFrame frm,FDBFileIO fIO){
		super(frm,"ʉw",true);
		//
		frame=frm;
		fileIO=fIO;
		//
		//
		ButtonGroup bg=new ButtonGroup();
		bg.add(defaultRadio);
		bg.add(offRadio);
		bg.add(folderRadio);
		defaultRadio.setSelected(true);
		enableButton();
		//
		JPanel panelRadio=new JPanel();
		panelRadio.add(defaultRadio);
		panelRadio.add(offRadio);
		panelRadio.add(folderRadio);
		panelRadio.add(typeCombo);
		typeCombo.setSelectedItem("wav");
		//
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonFolder);
		panelBtn.add(buttonOk);
		panelBtn.add(buttonCancel);
		//
		setLayout(new BorderLayout());
		add(panelRadio,BorderLayout.CENTER);
		add(panelBtn,BorderLayout.SOUTH);
		//ẽCxg
		defaultRadio.addChangeListener(this);
		offRadio.addChangeListener(this);
		folderRadio.addChangeListener(this);
		buttonFolder.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//*************************************************************
	//_CAO\Ȍ
	//-------------------------------------------------------------
	public void setLatestData(int snd){
		switch(snd){
		case FDBFrame.SND_IN:
			defaultRadio.setSelected(true);
			break;
		case FDBFrame.SND_OFF:
			offRadio.setSelected(true);
			break;
		case FDBFrame.SND_OUT_AU:
			folderRadio.setSelected(true);
			typeCombo.setSelectedItem("au");
			break;
		case FDBFrame.SND_OUT_WAV:
			folderRadio.setSelected(true);
			typeCombo.setSelectedItem("wav");
			break;
		default:
			defaultRadio.setSelected(true);
		}
		//
		enableButton();
	}
	//*************************************************************
	//Cxg
	//-------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {	//Button
		Object object=e.getSource();
		if(object==buttonFolder){					//O
			//tH_w
			File dir=fileIO.chooseFolder("ʉtH_I", "I", null);
			if(dir==null){	return;		}
			//ƃtH_̌ʉtH_ɃRs[
			String ext=(String)typeCombo.getSelectedItem();
			fileIO.copySEFiles(dir, ext);	//ŐdeleteSEFolder()
			//{ݒt@CύX
			if(ext.equals("au")){
				frame.changeBaseSetting(FDBFrame.SND_OUT_AU);
			}else if(ext.equals("wav")){
				frame.changeBaseSetting(FDBFrame.SND_OUT_WAV);
			}
			//ݒύXʒm
			fileIO.changePuzzle(false);
			//pYăX^[g
			frame.restartPuzzle(true);
			//
			setVisible(false);
		}else if(object==buttonOk){					//AIt
			//svɂȂʉ폜
			fileIO.deleteSEFolder();
			//{ݒt@CύX
			if(defaultRadio.isSelected()){
				frame.changeBaseSetting(FDBFrame.SND_IN);
			}else if(offRadio.isSelected()){
				frame.changeBaseSetting(FDBFrame.SND_OFF);
			}
			//ݒύXʒm
			fileIO.changePuzzle(false);
			//pYăX^[g
			frame.restartPuzzle(true);
			//
			setVisible(false);
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	public void stateChanged(ChangeEvent e) {		//RadioButton
		enableButton();
	}
	//*************************************************************
	//
	//-------------------------------------------------------------
	private void enableButton(){
		if(folderRadio.isSelected()){
			buttonFolder.setEnabled(true);
			buttonOk.setEnabled(false);
			typeCombo.setEnabled(true);
		}else{
			buttonFolder.setEnabled(false);
			buttonOk.setEnabled(true);
			typeCombo.setEnabled(false);
		}
	}
}
